###################################################################
## Moves GSM outputs to storage drive


##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


cat <<EOF
##############################################################
## GSMOut

EOF

err=1

log mv ${execGSM}/newBerg.nc ${strDir}/${no}/main/loveclim/nc/berg`printf %07d ${nextOrby}`.nc
log mv ${execGSM}/newIcemask.nc ${strDir}/${no}/main/loveclim/nc/icemask`printf %07d ${nextOrby}`.nc
log mv ${execGSM}/NA.nc ${strDir}/${no}/main/GSM/topo/nc/NA`printf %07d ${nextOrby}`.nc
log mv ${execGSM}/EA.nc ${strDir}/${no}/main/GSM/topo/nc/EA`printf %07d ${nextOrby}`.nc
log cp ${execGSM}/f32.unique ${strDir}/${no}/main/GSM/runoff/f32`printf %07d ${nextOrby}`.unique
log cp ${execGSM}/fE32.unique ${strDir}/${no}/main/GSM/runoff/fE32`printf %07d ${nextOrby}`.unique


## Backup GSM high-resolution topo files
log cd ${execGSM}
log tar -czf fort`printf %07d ${nextOrby}`.tar.gz fort.201 fort.202
rm fort.201 fort.202
log mv -f ${execGSM}/fort`printf %07d ${nextOrby}`.tar.gz ${strDir}/${no}/main/GSM/topo

echo "Backing up GSM topo files DONE for iteration " ${iter}


## Backup slope files
log tar -czf slope`printf %07d ${nextOrby}`.tar.gz fort.360 fort.365
log mv -f ${execGSM}/slope`printf %07d ${nextOrby}`.tar.gz ${strDir}/${no}/main/GSM/slope
echo "Backing up GSM slope files DONE for iteration " ${iter}


## Should be done some where else, but for now!
## Remove climate fields
rm ${execGSM}/fort.31[1-9]
rm ${execGSM}/fort.32[1-9]


### Restart files are rsync'ed by rsiNE.* ... no need for backup
## Backup GSM exec directory
# log cd ${execGSM}
# log tar -czf fort`printf %07d ${nextOrby}`.tar.gz *
# Remove the last restart file (they are really big files!)
# if [[ $? == '0' ]]; then
#     err=0
#     rm ${strDir}/${no}/main/GSM/restart/*
#     err=1
#     log mv -f ${execGSM}/fort`printf %07d ${nextOrby}`.tar.gz ${strDir}/${no}/main/GSM/restart
# fi

# echo "Backing up GSM restart files DONE for iteration " ${iter}

err=0

## Log successfulness of GSM for later possible continue runs
cat<<EOF >> ${strDir}/${no}/trash/steps.log
GSM @ `date` : year ${orby} to ${nextOrby}
EOF


cat <<EOF

## GSMOut
##############################################################

EOF
