#############################################################
## Copy "berg.nc" and "icemask.nc" from GSM to Loveclim
##
## exported variables:
##                    ${execLove}
##                    ${execGSM}


##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
        echo $@
    fi
}


cat <<EOF
##############################################################
## cpGSMLove

EOF

err=1

if [[ ${love} == '1' ]]; then
    log cp -f ${execGSM}/newBerg.nc ${execLove}/LOVECLIM/V1.3/scenario/Default/berg.nc
    log cp -f ${execGSM}/newIcemask.nc ${execLove}/LOVECLIM/V1.3/scenario/Default/icemask.nc
fi

err=0


cat <<EOF

## cpGSMLove
##############################################################

EOF

