##################################################
## Copy "fort" files from Loveclim Storage to GSM execution
## The copy MUST be from LOVECLIM storage to enable the code
## to work when LOVECLIM is turned off.

##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


atmfortStrPath=${strDir}/${no}/main/loveclim/dat

cat <<EOF
##############################################################
## cpLoveGSM

EOF

err=1

log cd ${atmfortStrPath}
## If there are more than one fort file:

if [[ `ls | wc -l` -gt 1 ]]; then
    log fort=fort`printf "%07d" $((orby+dOrby))`.tar.gz
else
    log fort=`ls *`
fi
log cp -f ${atmfortStrPath}/${fort} ${execGSM}
log cd ${execGSM}
log tar -xzf ${fort}
log rm ${fort}

err=0


cat <<EOF

## cpLoveGSM
##############################################################

EOF
