## Preparing Loveclim outputs and other neccessary
##  files for conversion
## Also copying all restart files for possible
##  future continue runs
## Then removes everything from the node scratch
##  directory to free up space
## This code runs after Loveclim is done
##  i.e., after ./launch_r1 in the submit script


##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}

cat <<EOF
##############################################################
### loveOutEns

EOF


log atmOUTPath=${execLove}/OUTPUT/run/OUTPUT/run/STORAGE/LOVECLIM1.3/run/repo/output/atmos
log ocnOUTPath=${execLove}/OUTPUT/run/OUTPUT/run/STORAGE/LOVECLIM1.3/run/repo/output/ocean
log vegOUTPath=${execLove}/OUTPUT/run/OUTPUT/run/STORAGE/LOVECLIM1.3/run/repo/output/veget
tmpFortDir=${execLove}/OUTPUT/run/OUTPUT/run/STORAGE/LOVECLIM1.3/run/repo/output/tmpFortDir

## User Edit End
##############################################################

rm -r ${tmpFortDir} 2>/dev/null
err=1

mkdir ${tmpFortDir}
log cp ${atmOUTPath}/tmp/fort.* ${tmpFortDir}
log cp ${ocnOUTPath}/fort.* ${ocnOUTPath}/ToceanSPECv1.*.dat ${tmpFortDir}
log cp ${execGSM}/fort.360 ${execGSM}/fort.365 ${tmpFortDir}
log cd ${tmpFortDir}
log tar -czf fort`printf %07d ${nextOrby}`.tar.gz *
log mv fort`printf %07d ${nextOrby}`.tar.gz ${strDir}/${no}/main/loveclim/dat

log mv ${atmOUTPath}/tmp/output.nc ${strDir}/${no}/main/loveclim/nc/glClim`printf %07d ${nextOrby}`.nc
log mv ${atmOUTPath}/tmp/outputNAGr.nc ${strDir}/${no}/main/loveclim/nc/NAclim`printf %07d ${nextOrby}`.nc
log mv ${atmOUTPath}/tmp/outputEA.nc ${strDir}/${no}/main/loveclim/nc/EAclim`printf %07d ${nextOrby}`.nc

log mv ${vegOUTPath}/evolu.`printf %06d ${loveYear}`_001 ${strDir}/${no}/main/loveclim/stat/evolu.`printf %07d ${nextOrby}`

log mv ${execLove}/RUN/V1.3/expdir/run/log/subrepo.log ${strDir}/${no}/trash/subrepo.log.`printf %07d ${nextOrby}`

log cd ${execLove}/RUN/V1.3/expdir/run/repo/
log lastIC=`ls -d ic* | tail -n1`
log tar -czf ${lastIC}.tar.gz ${lastIC}
log mv ${lastIC}.tar.gz ${strDir}/${no}/main/loveclim/ic/
echo "## ${lastIC} tarred and backed up."

err=0

## Log successfulness of Loveclim run for later possible continue runs
cat<<EOF >> ${strDir}/${no}/trash/steps.log
Loveclim @ `date` : year ${orby} to ${nextOrby}
EOF


cat <<EOF

### loveOutEns
##############################################################

EOF
