##############################################################################
## Enable/Disable variables based on parameter file

##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}

cat<<EOF
##############################################################
### loveOutVarEnableEns

EOF

atmdiag=LOVECLIM/V1.3/ecbilt/sources/atmdiag0.f
# atmdiag=RUN/V1.3/expdir/run10y/repo/compil/atmdiag0.f
if [[ ${ts} -eq '1' ]]; then
    sed -i '/!T\ surface\ temperature/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${t2m} -eq '1' ]]; then
    sed -i '/!T\ 2m\ temperature/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${t4g} -eq '1' ]]; then
    sed -i '/!T\ 650\ hPa\ temperature/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${evap} -eq '1' ]]; then
    sed -i '/!T\ evaporation/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${prec} -eq '1' ]]; then
    sed -i '/!T\ precipitation/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${wind10m} -eq '1' ]]; then
    sed -i '/!T\ wind\ 10\ m/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${wind200} -eq '1' ]]; then
    sed -i '/!T\ wind\ X\/Y\ 200\ hPa/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${wind500} -eq '1' ]]; then
    sed -i '/!T\ wind\ X\/Y\ 500\ hPa/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${wind800} -eq '1' ]]; then
    sed -i '/!T\ wind\ X\/Y\ 800\ hPa/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${sp} -eq '1' ]]; then
    sed -i '/!T\ surface\ pressure/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${t2g} -eq '1' ]]; then
    sed -i '/!T\ 350\ hPa\ temperature/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${t0g} -eq '1' ]]; then
    sed -i '/!T\ stratosphere\ temperature/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${dyprec} -eq '1' ]]; then
    sed -i '/!T\ dynamic\ precipitation/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${coprec} -eq '1' ]]; then
    sed -i '/!T\ convection\ precipitation/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${snow} -eq '1' ]]; then
    sed -i '/!T\ total\ snow/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${snowa} -eq '1' ]]; then
    sed -i '/!T\ land\ snow\ depth/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${gph} -eq '1' ]]; then
    sed -i '/!T\ geopotential\ height/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi
if [[ ${rh} -eq '1' ]]; then
    sed -i '/!T\ relative\ humidity/ s/c\$\$\$/    /' ${execLove}/${atmdiag}
fi


cat<<EOF

### loveOutVarEnableEns
##############################################################

EOF
