#############################################
## Submits the job from the scratch directory
## of the node

##############################################################
### ERROR HANDLING
### Modified for loveRUN at the end of code
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


cat<<EOF
##############################################################
### loveRunEns

EOF


errCnt=0

# while [ ${err} -ne 0 ] && [ ${errCnt} -le 10 ]; do
while :; do

    cd ${execLove}/RUN/V1.3/expdir
    # if [[ ! -e run ]]; then
    # 	./newexp exp.param
    # fi

    if [[ -e run ]]; then
	echo "run directory is not removed by prepLoveNextEns.sh!"
	exit 1
    fi

    chmod +x newexp
    log ./newexp exp.param

    cd run
    log cp run.param ${strDir}/${no}/trash/exp.param${orby}

    echo " Loveclim starts at " `date`
    chmod +x launch_r1
    ./launch_r1
    echo " Loveclim ends at " `date`
    
    ## Checks if Loveclim completed a full cycle
    grep "$((loveYear+loveYearStep-1))\[#################100.0%################\]" log/subrepo.log > /dev/null
    log goodEnd=$?

    grep "segmentation fault occurred" log/subrepo.log > /dev/null
    log segEnd=$?

    grep "USE" log/subrepo.log > /dev/null
    log useErr=$?

    log lastRunYear=`grep "[0-9]\[" log/subrepo.log | tail -1 | cut -d[ -f1 | sed 's/ //g'`

    if [[ ${goodEnd} == '0' ]]; then
	break;
#     elif [[ ${segEnd} == '0' ]]; then
# 	cp -v ${execLove}/RUN/V1.3/expdir/run/log/subrepo.log ${strDir}/${no}/trash/spn.subrepo.log.`printf %07d ${nextOrby}`.SEG
# 	cat <<EOF
# "########################"
# "## Segmentation fault ##"
# "########################"
# EOF
# 	exit 1
    elif [[ ${useErr} == '0' ]]; then
	log rm -r ${execLove}/RUN/V1.3/expdir/run
	continue
    elif [[ ${lastRunYear} -ne $((loveYear+loveYearStep-1)) ]] || \
	[[ ${segEnd} == '0' ]]; then
	## LOVECLIM stops with no reason/Segmentation fault
	## Try smaller atmospheric time-steps (default: iatm=6 <- No. of steps in a day)

	if [[ -e ${execLove}/RUN/V1.3/expdir/exp.param.backup ]]; then
	    echo "## LOVECLIM failed even with 1 hr time-step ... exit."
	    exit 1
	fi

	echo "## Atmosphere time-step switch to 1 hr (iatm=24)."
	log cp ${execLove}/RUN/V1.3/expdir/exp.param ${execLove}/RUN/V1.3/expdir/exp.param.backup
	log cp ${execLove}/RUN/V1.3/expdir/run/run.param ${execLove}/RUN/V1.3/expdir/exp.param
	sed -i '334s/6/24/' ${execLove}/RUN/V1.3/expdir/ref/comp_run-emic_loveclim
	sed -i '2770s/180/720/' ${execLove}/LOVECLIM/V1.3/ecbilt/sources/atmdiag0.f
	sed -i '2926s/180/720/' ${execLove}/LOVECLIM/V1.3/ecbilt/sources/atmdiag0.f
	log rm -r ${execLove}/RUN/V1.3/expdir/run

	## Now go for rerun with iatm=24
	continue
    fi


    log errCnt=$((errCnt+1))
    if [[ ${errCnt} -ge 10 ]]; then
	cat <<EOF
"######################"
"## Repeatative Run! ##"
"######################"
EOF
	
	exit 1
    fi
    
done

echo "## LOVECLIM run finished successfully."


cat<<EOF

### loveRunEns
##############################################################

EOF
