############################################################
### Copies the GSM rsiNE.* files into the computational 
##         node


##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


cat <<EOF
############################################################
## prepGSM

EOF

err=1

log mkdir ${execGSM}

if [[ ${cnt} == '0' ]] || ([[ ${cnt} == '1' ]] && [[ ${iter} == '1' ]]); then
    log mkdir -p ${strDir}/${no}/main/GSM/restart \
	${strDir}/${no}/main/GSM/topo/nc \
	${strDir}/${no}/main/GSM/log \
	${strDir}/${no}/main/GSM/slope \
	${strDir}/${no}/main/GSM/runoff

    sed "s/TIME/${orby}/" ${cplCndDir}/IC/${it}/fort.360.10x5 > ${execGSM}/fort.360
    sed "s/TIME/${orby}/" ${cplCndDir}/IC/${it}/fort.365.10x5 > ${execGSM}/fort.365
else
    ## Copy slope file from the slope dir
    log tar -xzf ${strDir}/${no}/main/GSM/slope/slope`printf %07d ${orby}`.tar.gz -C ${execGSM}/
    
    ## Copy runoff files to the GSM direcotry to be used by LOVECLIM
    cd ${strDir}/${no}/main/GSM/runoff/
    log cp `ls f32.*.unique | head -1` ${execGSM}/f32.unique
    log cp `ls fE32.*.unique | head -1` ${execGSM}/fE32.unique
fi

# if [[ ${orby} -gt -80000 ]] && [[ ${orby} -lt -5000 ]]; then
#     cp -v ${modelsDir}/coupler/conditions/gsmIC/${gsmIC}/* ${execGSM}
# fi


log cp ${gsmSourceDir}/rsiNE.* ${execGSM}
log cp ${gsmSourceDir}/makeoutNAEAstep ${execGSM}

if [[ ${era} == 'LGM' && ${iter} == '1' ]]; then
    log cp ${cplCndDir}/IC/${it}/restartVE   ${execGSM}/fort.19
    log cp ${cplCndDir}/IC/${it}/restartSGk1 ${execGSM}/fort.111
    log cp ${cplCndDir}/IC/${it}/restartSGk2 ${execGSM}/fort.112
    log cp ${cplCndDir}/IC/${it}/restartk1   ${execGSM}/fort.31
    log cp ${cplCndDir}/IC/${it}/restartk2   ${execGSM}/fort.32

    ## WRONG, but no choice for now!
    log sed "2s/TIME/${orby}/" ${cplCndDir}/IC/${it}/fort.360.10x5 > ${execGSM}/fort.360
    log sed "2s/TIME/${orby}/" ${cplCndDir}/IC/${it}/fort.365.10x5 > ${execGSM}/fort.365
fi

## Copy upscaling files to the execGSM directory
log cp ${execCpl}/regrid* ${execGSM}
log cp ${cplCndDir}/topo/topoGSMhighRes.nc ${execGSM}/topoGSMres.org.nc

err=0

cat <<EOF

## prepGSM Done
############################################################

EOF
