##############################################################
### Prepares Loveclim for next time-step
##
##  exported needs:
##                 ${loveSrcDir}
##                 ${execDir}
##                 ${strDir}
##                 ${no}
##                 ${orby}
##############################################################

##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


cat<<EOF
##############################################################
### prepLoveSpinMainEns

EOF


err=1

# if [[ ${ghg} == '1' ]]; then
#     awk -v "loveYear=${loveYear}" '$1=loveYear+NR-1 {print}' ${cplCndDir}/GHG/GHG`printf %06d $((-1*orby))`.dat > \
# 	${execLove}/LOVECLIM/V1.3/scenario/Default/GHG.dat
# fi

## GSM can only 100 years in first step (ie after spin up), so:
log lengthInDays=$((100*360))

cd ${execCpl}/forcing
log eccf=`echo ${orby} | ./orbParmSeparate.o | awk '{print $1}' | sed -n '1p'`
log oblf=`echo ${orby} | ./orbParmSeparate.o | awk '{print $1}' | sed -n '2p'`
log omwebf=`echo ${orby} | ./orbParmSeparate.o | awk '{print $1}' | sed -n '3p'`


## Update exp.param
sed -i "s/start_y=.*/start_y=${loveYear}/" ${execLove}/RUN/V1.3/expdir/exp.param
sed -i "s/lengthInDays=.*/lengthInDays=${lengthInDays}/" ${execLove}/RUN/V1.3/expdir/exp.param
sed -i "s/eccf=.*/eccf=${eccf};oblf=${oblf};omwebf=${omwebf}/" ${execLove}/RUN/V1.3/expdir/exp.param


# mv ${execLove}/RUN/V1.3/expdir/run ${execLove}/RUN/V1.3/expdir/run.spinup
# rm -r ${execLove}/OUTPUT

err=0


cat<<EOF

### prepLoveSpinMainEns
##############################################################

EOF
