##############################################################
### ERROR HANDLING
##  err: Determines important errors from unimportant errors
##       Set it to a non-zero value before commands to stop
##        if they fail, and zero after them again
##       e.g.: err=1
##             command; err=0

err=0
error() {
    if [ ${err} -ne '0' ]; then
        echo "file $(basename $0) failed at line $1"
        exit 1
    fi
}
trap 'error ${LINENO}' ERR
##############################################################


log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
        echo $@
    fi
}


err=0
rm f32.unique fE32.unique
err=1

if [[ ! -e fort.254.runoff ]] || [[ ! -e fort.264.runoff ]]; then
    echo "## fort.2[56]4.runoff do(es) NOT exist!"
    exit 1
fi


## Remove header from files if they exist
if [[ `grep "#" fort.254.runoff` ]]; then
    sed -i 1,2d fort.254.runoff
fi
if [[ `grep "#" fort.264.runoff` ]]; then
    sed -i 1,2d fort.264.runoff
fi


python <<EOF
import numpy as np
import glob


##  NA+Gr
fileName = "fort.254.runoff"

data = np.loadtxt(open(fileName, "r"))

ext = np.zeros((336*198,3))


for j in range(198):
    for i in range(336):
        ext[i+j*336][0] = i
        ext[i+j*336][1] = 198-j-1
        ext[i+j*336][2] = np.sum(data[np.where( (data[:,0]==i) & (data[:,1]==198-j-1))][:,5])


np.savetxt('f32.unique', ext[:,2], fmt='%4.3f')


##  EA
fileName = "fort.264.runoff"

data = np.loadtxt(open(fileName, "r"))

ext = np.zeros((266*142,3))


for j in range(142):
    for i in range(266):
        ext[i+j*266][0] = i
        ext[i+j*266][1] = 142-j-1
        ext[i+j*266][2] = np.sum(data[np.where( (data[:,0]==i) & (data[:,1]==142-j-1))][:,5])


np.savetxt('fE32.unique', ext[:,2], fmt='%4.3f')

EOF

rm fort.254.runoff fort.264.runoff
