#!/bin/env bash

log()
{
    eval $@
    if [[ ${debug} == 1 ]]; then
	echo $@
    fi
}


cat<<EOF
######################################################
### setFerret.sh

EOF


# log export FER_DIR="/usr/local/ferret-6.8.4.2"
log export FER_DIR="/usr/local/ferret-6.96"

export FER_DAT=${FER_DIR}
export FER_DATA_THREDDS="http://ferret.pmel.noaa.gov/geoide/geoIDECleanCatalog.xml ${FER_DIR}/fer_dsets"
export FER_EXTERNAL_FUNCTIONS="${FER_DIR}/ext_func/libs"
export FER_GO=". ${FER_DIR}/go ${FER_DIR}/examples ${FER_DIR}/contrib /home/tbahador/myScripts"
export FER_LIBS="${FER_DIR}/lib"
export FERRET=${FER_DIR}
export FER_DATA=". ${FER_DIR}/fer_dsets/data ${FER_DIR}/go ${FER_DIR}/examples"
export FER_DESCR=". ${FER_DIR}/fer_dsets/descr"
export FER_DSETS="${FER_DIR}/fer_dsets"
export FER_FONTS="${FER_DIR}/ppl/fonts"
export FER_GRIDS=". ${FER_DIR}/fer_dsets/grids"
export FER_PALETTE=". ${FER_DIR}/ppl"
export PLOTFONTS="${FER_DIR}/ppl/fonts"
export SPECTRA="${FER_DIR}/ppl"

export ferret=${FER_DIR}/bin/ferret


cat<<EOF

### setFerret.sh
######################################################

EOF
