c23456789012345678901234567890123456789012345678901234567890123456789012
      subroutine ec_co2oc(ist)
c----------------------------------------------------------------------
c *** communicate data from coupler to ocean
c----------------------------------------------------------------------

#define ISOTOPE 0
#define KATA 0
#define NUDGING 0
#define ISM 0

      include 'type.com'

      include 'comcouphelp.h'
      include 'comcoup.h'

      include 'para.com'
      include 'bloc.com'
      include 'ice.com'
      include 'dynami.com'
      include 'const.com'
#if NUDGING == 1
      include 'comsurf.h'
      include 'st_noise.com'
#endif

#if KATA == 2
      real, dimension (imax,jmax) :: corr_map_taux_p, corr_map_taux_x, corr_map_tauy_p, corr_map_tauy_x
#endif
      dimension zlatt(imax,jmax),zlont(imax,jmax)
      real*8 frwism(imax,jmax),deltamass,massGold,massAold
      real*8  day
      integer iyear,imonth,iday,iseason,nbclins,nbtrops,ntotday
      integer ntstep,nstpyear,nocstpyear
      integer nyears,ndays,irunlabel,irunlabeld,iatm,ilan,iice,iobtrop,iobclin,
     *            nwrskip,nwrskip_days,end_year,end_day
      logical flgveg,flgicb,flgism,flgisma,flgismg

      COMMON/AG2CLIO2/frwism,deltamass,massGold,massAold 
      common /ec_coupl/ flgveg,flgicb,flgisma,flgismg
      common /ec_timectl/ day,ntstep,nstpyear,nocstpyear,
     *                 iyear,imonth,iday,iseason,ntotday,nbclins,nbtrops
      common /ec_timepar/ nyears,ndays,irunlabel,irunlabeld,iatm,ilan,iice,iobtrop,iobclin,
     *                 nwrskip,nwrskip_days,end_year,end_day
      common / coord /  zlont,zlatt 


      real*8 zfld(imax,jmax)
      integer ix,jy,ist

#if NUDGING == 1
      real*8  tsurf4nudge(nlat,nlon)
      real*8  count4nudge
      real*8  nudgingTs(nlat,nlon)
      real*8  sumohfx_nudging(nlat,nlon)
      real*8  stnoiseTs(nlat,nlon)
      integer dimnudge
      character(len=256) Clioarea
      character(len=256) Cliogrid
      character(len=256) eoffile
      character(len=256) resfile
      character(len=256) alphafile
      character(len=256) fcostEPFfile
      character(len=256) stoutfile
      real*8 relaxcoefNoise,sigmaEPF
      integer wrtstnoise
      common /ec_nudging/ tsurf4nudge,count4nudge,nudgingTs
      common /ec_stnoise/ stnoiseTs
      common / ec_nudgingParam / dimnudge, Clioarea, Cliogrid,
     &                           eoffile,resfile,alphafile,relaxcoefNoise,sigmaEPF,
     &                           fcostEPFfile,stoutfile,wrtstnoise 

      integer ii
      real*8  stnoise2DTemp(imax,jmax), stnoise2DTempAn(imax-2,jmax,12)
      real*8  nudging2DTemp(imax,jmax), nudging2DTempAn(imax-2,jmax,12)
      real*8  numbnois2D(12), numbnudg2D(12)
      common /ec_stnoise2D/ stnoise2DTemp, stnoise2DTempAn, numbnois2D
      common /ec_nudging2D/ nudging2DTemp, nudging2DTempAn, numbnudg2D

      real*8 varEPF,accuEPF,fcostEPF,accuEPF1,accuEPF2,maxarea
      common /ec_fcostEPF2D/ accuEPF, fcostEPF, maxarea
#endif

c *** zonal wind stress 
      call at2oc(winstua,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
           tairox(ix,jy) = zfld(ix,jy)
           tenagx(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** meridional wind stress 
      call at2oc(winstva,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
           tairoy(ix,jy) = zfld(ix,jy)
           tenagy(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** short wave radiation over ocean 
      call at2oc(sumoswr,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
          fsolcn(ix,jy) = zfld(ix,jy)
        enddo
      enddo
#if ISOTOPE == 1
c *** Isotope Oxygen 18
      call at2oc(sumoiof,zfld)
      do ix = 1, imax
        do jy = 1, jmax
          foxy18(ix,jy) = zfld(ix,jy)*86400.*1000.
        enddo
      enddo
c      write(99,*)'foxy18p88',foxy18(8,8)
c      write(99,*)'foxy18p6028',foxy18(60,28)
c      write(99,*)'sumoiof(5,5)',sumoiof(5,5)
c      write(99,*)'sumoiofOC',sumoiof
c *** Isotope Deuterium
      call at2oc(sumoidf,zfld)
      do ix = 1, imax
        do jy = 1, jmax
          fdeute(ix,jy) = zfld(ix,jy)*86400.*1000.
        enddo
      enddo
c      write(99,*)'fdeutep88',fdeute(8,8)
c      write(99,*)'fdeutep6028',fdeute(60,28)
c      write(99,*)'sumoidfOcean',sumoidf(5,5)
c      write(99,*)'sumoidfOC',sumoidf
#endif
c *** net fresh water flux over ocean/sea-ice
      call at2oc(sumofwf,zfld)    
           areat=0.
           x1=280*pi/180
           x2=360*pi/180
           y1=20*pi/180
           y2=50*pi/180
      do ix = 1, imax
        do jy = 1, jmax
          fwat(ix,jy) = -zfld(ix,jy)*86400.*1000.
#if ISM == 1 
          fwat(ix,jy)=fwat(ix,jy)+(frwism(ix,jy)*86400.*1000.) 
#endif 
c ecrespin:mettre la valeur du flux eau douce dans Sv  
        if (ihyster.ne.0) then
          sv=xfreshsv(irunlabel+iyear-ihyster+1)
!  write(99,*) 'sv xfreshsv',sv, irunlabel+iyear-ihyster+1
        else
          sv=0.0
        endif
          if ((zlont(ix,jy).le.x2).and.(zlont(ix,jy).ge.x1).and.
     &    (zlatt(ix,jy).le.y2).and.(zlatt(ix,jy).ge.y1)) then
           areat=areat+(area(ix,jy)*tms(ix,jy,ks2))
          endif
        enddo
      enddo
c     write(*,*)'total',areat
      do ix = 1, imax
        do jy = 1, jmax
          if ((zlont(ix,jy).le.x2).and.(zlont(ix,jy).ge.x1).and.
     &    (zlatt(ix,jy).le.y2).and.(zlatt(ix,jy).ge.y1)) then
           fwat(ix,jy)=fwat(ix,jy)+((sv*1.E+6/areat)*86400.*1000.)
          endif
        enddo
      enddo

#if NUDGING == 1
c--- DUBINKINA (09/2011)
c--- Calculating and saving st.noise and nudging >>>
      if(ist.eq.1) then
        accuEPF=0.
        maxarea=0.
	do ix = 1, imax
	  do jy = 1, jmax
	    if ((area(ix,jy)).gt.maxarea) maxarea=area(ix,jy)
	  enddo
	enddo
      endif
c --- Nudging
      accuEPF2=0.
      sumohfx_nudging=-nudgingTs
      call at2oc(sumohfx_nudging,zfld) 
      do ix = 1, imax
        do jy = 1, jmax
          nudging2DTemp(ix,jy) = zfld(ix,jy)*dts(ks2)/rhocp_st/h_st
          accuEPF2=accuEPF2 + (area(ix,jy)/maxarea)*(nudging2DTemp(ix,jy)**2*1.0/sigmaEPF)
        enddo
      enddo
      call year_accum(nudging2DTemp,nudging2DTempAn,numbnudg2D,ist)  
c--- St.noise 
      accuEPF1=0.
      sumohfx_nudging=-stnoiseTs
      call at2oc(sumohfx_nudging,zfld)  
      do ix = 1, imax
        do jy = 1, jmax
          stnoise2DTemp(ix,jy) = zfld(ix,jy)*dts(ks2)/rhocp_st/h_st
          varEPF=stnoise2DTemp(ix,jy)+nudging2DTemp(ix,jy)
          accuEPF1=accuEPF1 + (area(ix,jy)/maxarea)*(stnoise2DTemp(ix,jy)**2*1.0/sigmaEPF)
	  !! Remark by Andrew Lorenc, see "Nonlinear data assimilation in geosciences: an extremely efficient PF"
	  !! by P.J. van Leeuwen. The following can be eliminated from the weights
	  !! accuEPF=accuEPF+(area(ix,jy)/maxarea)*(-stnoise2DTemp(ix,jy)**2*1.0/sigmaEPF) 
	  !! since the corresponding pdf is equal to ONE for every particle! 
          accuEPF=accuEPF+(area(ix,jy)/maxarea)*varEPF**2*1.0/sigmaEPF
        enddo
      enddo
      call year_accum(stnoise2DTemp,stnoise2DTempAn,numbnois2D,ist) 
c--- Writing to a file
      if (ist.eq.wrtstnoise) then 
	 !Writing fcost
         fcostEPF=exp(-accuEPF/2.)
         if (dimnudge.ne.0) call write_fcostEPF
! 	 write(*,*) " "
! 	 write(*,*)'last accuEPF from Nudging',accuEPF2
! 	 write(*,*)'last accuEPF from Noise',accuEPF1
! 	 write(*,*)'fcostEPF',fcostEPF,'total accuEPF',accuEPF
! 	 write(*,*) " "

	 !Writing surface nudging, noise
         call write_stnoise
      endif 
c <<< Calculating and saving st,noise and nudging

c--- ZUNZ 
c *** net heat flux over ocean without solar flux
      sumohfx_nudging=sumohfx-nudgingTs-stnoiseTs
      call at2oc(sumohfx_nudging,zfld)
#else
      call at2oc(sumohfx,zfld)    
#endif
      do ix = 1, imax
        do jy = 1, jmax
          ratbqo(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** net snowflux over sea-ice 
      call at2oc(sumisno,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
          hnplbq(ix,jy) = max (zero,zfld(ix,jy)*86400.*1000.)
        enddo
      enddo
c *** short wave radiation over sea-ice 
      call at2oc(sumiswr,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
          fsolg(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** net heat flux over sea-ice without solar flux
      call at2oc(sumihfx,zfld)    
      do ix = 1, imax
        do jy = 1, jmax
          ratbqg(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** coefficients sensible-heat flux for implicit ice-temperature calculation
      call at2oc(sumicof,zfld)
      do ix = 1, imax
        do jy = 1, jmax
          vabq(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** 10 meter height Wind Magnitude (m/s) for iceberg model  
      call at2oc(sumuv10,zfld)
      do ix = 1, imax
        do jy = 1, jmax
         temp_vent(ix,jy) = zfld(ix,jy)
        enddo
      enddo

c *** Surface pressure
      call at2oc(sumpress,zfld)
      do ix = 1, imax
        do jy = 1, jmax
         temp_press(ix,jy) = zfld(ix,jy)
        enddo
      enddo
c *** heat due to iceberg melting
      ficebergn=sumohsn
      ficebergs=sumohss
C     write(99,*) 'iceberg',ficebergn,ficebergs

C Rotation of the wind stress

      do ix = 1, imax
        do jy = 1, jmax
         tairox(ix,jy)  = tenagx(ix,jy)*xang2(ix,jy)-
     &                  tenagy(ix,jy)*xang1(ix,jy)
         tairoy(ix,jy)  = tenagy(ix,jy)*xang2(ix,jy)+
     &                  tenagx(ix,jy)*xang1(ix,jy)
        enddo
      enddo
      do ix = 1, imax
        do jy = 1, jmax
         tenagx(ix,jy)  = tairox(ix,jy)*1.4
         tenagy(ix,jy)  = tairoy(ix,jy)*1.4
        enddo
      enddo

#if KATA == 2
c
c Katabatic winds trough modification of wind stresses 
c
      open(unit=10, file='corr_map_taux_x.txt', status='old')
      open(unit=20, file='corr_map_taux_p.txt', status='old')
      open(unit=30, file='corr_map_tauy_x.txt', status='old')
      open(unit=40, file='corr_map_tauy_p.txt', status='old')
c
      do i=1,imax
       read(10,*) corr_map_taux_x(i,:)
       read(20,*) corr_map_taux_p(i,:)
       read(30,*) corr_map_tauy_x(i,:)
       read(40,*) corr_map_tauy_p(i,:)
      end do
c
      close(10)
      close(20)
      close(30)
      close(40)
c
      tenagx = corr_map_taux_x * tenagx + corr_map_taux_p * 1.4
      tenagy = corr_map_tauy_x * tenagy + corr_map_tauy_p * 1.4

      tairox = corr_map_taux_x * tairox + corr_map_taux_p
      tairoy = corr_map_tauy_x * tairoy + corr_map_tauy_p
c
#endif
      do ix = 1, imax
        do jy = 1, jmax
          fevabq(ix,jy) = 0.0
          fcscn(ix,jy) = 0.0
          flecn(ix,jy) = 0.0
        enddo
      enddo
      
c      zsumz1=0.0
c      do j=1,jmax
c        do i=is1(j),is2(j)
c          zsumz1=zsumz1+area(i,j)*tms(i,j,ks2)
c        enddo
c      enddo
c      zsumz=0.0
c      do j=1,jmax
c        do i=is1(j),is2(j)
c          zsumz=zsumz+area(i,j)*tms(i,j,ks2)*fwat(i,j)
c        enddo
c      enddo
c      write(97,*) zsumz/zsumz1,zsumz1

      return
 
      end

      subroutine at2oc(fin,fout)
      
      implicit none
      
      include 'comcouphelp.h'
      include 'comcoup.h'
      
      integer ji,jk,i,j
      real*8  fin(nlat,nlon),fout(ijocn),finf(ijatm),zsum
      
      ji=0
      do i=1,nlat
        do j=1,nlon
	  ji=ji+1
	  finf(ji)=fin(i,j)
	enddo
      enddo
      
      do ji = 1, ijocn
      zsum = 0.
        do jk = 1, komax
          zsum = zsum + wa2o(ji,jk) * finf(inda2o(ji,jk))
        enddo 
        fout(ji) = zsum
      enddo

#if NUDGING == 1      
      end

c------------------------------
c ***Subroutine write_fcostEPF***
c------------------------------

      subroutine write_fcostEPF

      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'netcdf.inc'

      include 'comcouphelp.h'
      include 'comemic.h'

      integer dimnudge
      character(len=256) Clioarea
      character(len=256) Cliogrid
      character(len=256) eoffile
      character(len=256) resfile
      character(len=256) alphafile
      character(len=256) fcostEPFfile
      character(len=256) stoutfile
      character(len=256) nudgefile
      integer wrtstnoise
      real*8 relaxcoefNoise,relaxcoef
      real*8 sigmaEPF,nudgemax

      common / ec_nudgingParam / dimnudge, Clioarea, Cliogrid,
     &                           eoffile,resfile,alphafile,relaxcoefNoise,sigmaEPF,
     &                           fcostEPFfile,stoutfile,wrtstnoise, 
     &                           nudgefile,relaxcoef,nudgemax

      real*8 accuEPF,fcostEPF
      common /ec_fcostEPF2D/ accuEPF, fcostEPF
      integer*4 iflag,ntries

      iflag=1
      ntries=1
      do while ((iflag.ne.0).and.(ntries.lt.100))
	open(10,file=fcostEPFfile,IOSTAT=iflag,status='new',form='formatted')
	write(10,'(f20.15)') fcostEPF
        close(10)
	ntries=ntries+1
	if ((iflag.ne.0).and.(mod(ntries,2).eq.0)) then
	  write(*,*) "Writing fcost to a file, an attempt number",ntries 
	  call sleep(10)
	endif
      enddo 

      end

c------------------------------
c ***Subroutine year_accum***
c------------------------------
      subroutine year_accum(nudging2DTemp,nudging2DTempAn,numbnudg2D,ist)

      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'netcdf.inc'

      include 'comcouphelp.h'
      include 'comemic.h'
      
      real*8  nudging2DTemp(imax,jmax), nudging2DTempAn(imax-2,jmax,12)
      real*8  numbnudg2D(12)

      integer ix,jy,ii,ist

      if(ist.eq.1) then
        do ii=1,12
          numbnudg2D(ii)=0.
          do ix=1,imax-2
            do jy=1,jmax
              nudging2DTempAn(ix,jy,ii)=0.
            enddo
          enddo
        enddo
      endif
      numbnudg2D(imonth)=numbnudg2D(imonth)+1.
      do ix=1,imax-2
        do jy=1,jmax
           nudging2DTempAn(ix,jy,imonth)=nudging2DTempAn(ix,jy,imonth)+nudging2DTemp(ix,jy)
        enddo
      enddo

      end


c------------------------------
c ***Subroutine write_stnoise***
c------------------------------

      subroutine write_stnoise

      include 'type.com'
      include 'const.com'
      include 'para.com'
      include 'bloc.com'
      include 'netcdf.inc'

      include 'comcouphelp.h'
      include 'comemic.h'

      integer dimnudge
      character(len=256) Clioarea
      character(len=256) Cliogrid
      character(len=256) eoffile
      character(len=256) resfile
      character(len=256) alphafile
      character(len=256) fcostEPFfile
      character(len=256) stoutfile
      real*8 relaxcoefNoise,sigmaEPF

      real*8  stnoise2DTemp(imax,jmax), stnoise2DTempAn(imax-2,jmax,12)
      real*8  nudging2DTemp(imax,jmax), nudging2DTempAn(imax-2,jmax,12)
      real*8  numbnois2D(12), numbnudg2D(12)

      common / ec_nudgingParam / dimnudge, Clioarea, Cliogrid,
     &                           eoffile,resfile,alphafile,relaxcoefNoise,sigmaEPF,
     &                           fcostEPFfile,stoutfile 

      common /ec_stnoise2D/ stnoise2DTemp, stnoise2DTempAn, numbnois2D
      common /ec_nudging2D/ nudging2DTemp, nudging2DTempAn, numbnudg2D

      integer fileNoiID,tempNoiID,saltNoiID,Nerror,tempNudID,saltNudID
      integer start(3),count(3),i,j,ii
      integer dimidx,dimidy,dimidt,dd(3)
      integer varidx,varidy,varidt
      real*8  xvals(imax-2),yvals(jmax),tvals(12)

      do ii=1,12
        do i=1,imax-2
          do j=1,jmax
              if ((numbnudg2D(ii)).ne.0) then
		nudging2DTempAn(i,j,ii)=nudging2DTempAn(i,j,ii)/numbnudg2D(ii)
	      else 
		nudging2DTempAn(i,j,ii)=0.
	      endif
              if ((numbnois2D(ii)).ne.0) then
	        stnoise2DTempAn(i,j,ii)=stnoise2DTempAn(i,j,ii)/numbnois2D(ii)
	      else
	        stnoise2DTempAn(i,j,ii)=0.
	      endif
          enddo
        enddo
      enddo

      start(1)=1
      start(2)=1
      start(3)=1

      count(1)=imax-2
      count(2)=jmax
      count(3)=12

c---  Get the grid
      Nerror=NF_OPEN(Cliogrid,NF_NOWRITE,fileNoiID)
c---  Get variable IDs
      Nerror=NF_INQ_VARID (fileNoiID,'lon',varidx)
      Nerror=NF_INQ_VARID (fileNoiID,'lat',varidy)
c --- Get contents of dimension variables
      Nerror=NF_GET_VARA_DOUBLE (fileNoiID,varidx,start(1),count(1),xvals)
      Nerror=NF_GET_VARA_DOUBLE (fileNoiID,varidy,start(2),count(2),yvals)
      Nerror=NF_CLOSE(fileNoiID)
      do i=1,12
        tvals(i)=1.0*i
      enddo

c---  Create a file 
      Nerror=NF_CREATE(stoutfile,NF_CLOBBER,fileNoiID)

c---  Define the dimensions
      Nerror=NF_DEF_DIM(fileNoiID,'lon',imax-2,dimidx)
      Nerror=NF_DEF_DIM(fileNoiID,'lat',jmax,dimidy)
      Nerror=NF_DEF_DIM(fileNoiID,'time',12,dimidt)

c---  Define the variables 
      dd(1)=dimidx
      Nerror=NF_DEF_VAR(fileNoiID,'lon',nf_double,1,dd,varidx)
      dd(1)=dimidy
      Nerror=NF_DEF_VAR(fileNoiID,'lat',nf_double,1,dd,varidy)
      dd(1)=dimidt
      Nerror=NF_DEF_VAR(fileNoiID,'time',nf_double,1,dd,varidt)

      dd(1)=dimidx
      dd(2)=dimidy
      dd(3)=dimidt
      Nerror=NF_DEF_VAR(fileNoiID,'temp_noise',nf_double,3,dd,tempNoiID)
      Nerror=NF_DEF_VAR(fileNoiID,'temp_nudg',nf_double,3,dd,tempNudID)

c---  Change mode of netCDF operation
      Nerror=NF_ENDDEF(fileNoiID)

c---  Output the values of the variables (include dimension variables)
      Nerror=NF_PUT_VARA_DOUBLE(fileNoiID,varidx,start(1),count(1),xvals)
      Nerror=NF_PUT_VARA_DOUBLE(fileNoiID,varidy,start(2),count(2),yvals)
      Nerror=NF_PUT_VARA_DOUBLE(fileNoiID,varidt,start(3),count(3),tvals)

c---  Main variables values
      Nerror=NF_PUT_VARA_DOUBLE(fileNoiID,tempNoiID,start,count,stnoise2DTempAn)
      Nerror=NF_PUT_VARA_DOUBLE(fileNoiID,tempNudID,start,count,nudging2DTempAn)

c---  Close the file
      Nerror=NF_CLOSE(fileNoiID)

#endif
      end

