      program albedo
c *** this program increases land area of the land albedos to accomodate
c *** changes in the land-sea mask

      implicit none
      
      integer   i,j,i1,j1,i2,j2,is,nlat,nlon
      parameter (nlat=32,nlon=64)
      real*8    albland(nlat,nlon,4),albsea(nlat,4),forestfr(nlat,nlon)
      real*8    albsnow(nlat,2)
      real*8    albland1(nlat,nlon,4)
      
      open(4,file='albedo.ori',form='formatted',status='old')
      open(1,file='albland.grads',form='unformatted',
     *access='direct',recl=32*64)
      open(2,file='albedo.dat',form='formatted')
      
c *** read land, snow and sea albedos
      
       read(4,*)
       do i=1,nlat
	 do j=1,nlon
	   read(4,44)(albland(i,j,is),is=1,4)
	 enddo
       enddo
44     format(4(2x,f8.4))

       read(4,*)
       do i=1,nlat
	 read(4,45)(albsea(i,is),is=1,4)
       enddo
45     format(4(2x,f7.4))
      
       read(4,*)
       do i=1,nlat
         do j=1,nlon
           read(4,46) forestfr(i,j)
         enddo
       enddo
46     format(f8.4)
      
       read(4,*)
       do i=1,nlat
         read(4,*) (albsnow(i,j),j=1,2)
       enddo

c *** increase landarea by taking neighbouring albedo values

      do i=1,nlat
        do j=1,nlon
          do is=1,4
            albland1(i,j,is)=albland(i,j,is)
            if (albland1(i,j,is).eq.0.) then
c *** first check if adjacent east-west neighbours are nonzero
                do j1=-1,1,2
                  j2=j+j1
                  if (j2.lt.1) j2=j2+nlon
                  if (j2.gt.nlon) j2=j2-nlon
                  if (albland(i,j2,is).ne.0.) then
                    albland1(i,j,is)=albland(i,j2,is)
                  endif
                enddo
            endif
            if (albland1(i,j,is).eq.0.) then
c *** next check next east-west neighbours
                do j1=-2,2,4
                  j2=j+j1
                  if (j2.lt.1) j2=j2+nlon
                  if (j2.gt.nlon) j2=j2-nlon
                  if (albland(i,j2,is).ne.0.) then
                    albland1(i,j,is)=albland(i,j2,is)
                  endif
                enddo
            endif
            if (albland1(i,j,is).eq.0.) then
c *** next check north-south neighbours
              do i1=-1,1,2
                  i2=i+i1
                  if (i2.ge.1.and.i2.le.nlat) then
                    if (albland(i2,j,is).ne.0.) then
                      albland1(i,j,is)=albland(i2,j,is)
                    endif
                  endif
              enddo
            endif
            
            if (albland1(i,j,is).eq.0.) then
c *** next check next north-south neighbours
              do i1=-2,2,4
                  i2=i+i1
                  if (i2.ge.1.and.i2.le.nlat) then
                    if (albland(i2,j,is).ne.0.) then
                      albland1(i,j,is)=albland(i2,j,is)
                    endif
                  endif
                enddo
            endif
            
            if (albland1(i,j,is).eq.0.) then
c *** next check diagonal neighbours
              do i1=-1,1,2
                do j1=-1,1,2
                  i2=i+i1
                  j2=j+j1
                  if (i2.ge.1.and.i2.le.nlat) then
                    if (j2.lt.1) j2=j2+nlon
                    if (j2.gt.nlon) j2=j2-nlon
                    if (albland(i2,j2,is).ne.0.) then
                      albland1(i,j,is)=albland(i2,j2,is)
                    endif
                  endif
                enddo
              enddo
            endif
10          continue
          enddo
        enddo
      enddo
      
      do is=1,4
        write(1) ((real(albland(i,j,is)),j=1,nlon),i=1,nlat)
        write(1) ((real(albland1(i,j,is)),j=1,nlon),i=1,nlat)
      enddo
      
c *** write new land and old snow and sea albedos
      
       write(2,*) '***   DJF       MAM       JJA       SON'

       do i=1,nlat
	 do j=1,nlon
	   write(2,44)(albland1(i,j,is),is=1,4)
	 enddo
       enddo

       write(2,*) '***  DJF      MAM      JJA      SON'//
     *'sea albedos zonal mean'

       do i=1,nlat
	 write(2,45)(albsea(i,is),is=1,4)
       enddo
      
       write(2,*) '***  forest fractions for snow albedo calculations'
       do i=1,nlat
         do j=1,nlon
           write(2,46) forestfr(i,j)
         enddo
       enddo
      
       write(2,*) '*** albedos of snow: old ones in second column'

       do i=1,nlat
         write(2,47) (albsnow(i,j),j=1,2)
       enddo
47     format(1F5.2,3X,1F5.2)
      end
            
            
