#!/bin/bash

echo "/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/"
echo "sub.sc param=($1, $2, $3)"
echo "/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/"

uname -n

#get argument and global variabe
texp={TEXP}
exp={EXP}
Rundir={RUNDIR}
paramdir=${Rundir}/expdir/$texp/$texp.param
source ${paramdir}
scratchdir={SCRATCHDIR}
loveclimdir={LOVECLIMDIR}
loveclimver={LOVECLIMVER}
SavingHost={SAVINGHOST}
numyear={NUMYEAR}
numday={NUMDAY}
numsave_y={NUMSAVEY}
numsave_d={NUMSAVED}
scenGHG={SCENGHG}
scenTSI={SCENTSI}
scenVolc={SCENVOLC}
scenVeget={SCENVEGET}
scenimsk={SCENIMSK}
scentopo={SCENTOPO}
scenfwf={SCENFWF}
master_dir={MASTERDIR}

#construct variable
runtime=$1
runtime_d=$(( (${runtime}-1)%360+1 ))
runtime_y=$(( (${runtime}-${runtime_d})/360 ))
fruntime_y=`printf "%06d\n" ${runtime_y}`
fruntime_d=`printf "%03d\n" ${runtime_d}`

ictime=$(( ${runtime}-1 ))
ictime_d=$(( (${ictime}-1)%360+1 ))
ictime_y=$(( (${ictime}-${ictime_d})/360 ))
fictime_y=`printf "%06d\n" ${ictime_y}`
fictime_d=`printf "%03d\n" ${ictime_d}`

runtimeNext_y=$((${runtime_y}+${numyear}))
runtimeNext_d=$((${runtime_d}+${numday}))
fruntimeNext_y=`printf "%06d\n" ${runtimeNext_y}`
fruntimeNext_d=`printf "%03d\n" ${runtimeNext_d}`

CLIOmodNameTRONQ=`printf "%.6s" ${texp}`
CLIOmodName=`printf "%-6s" ${CLIOmodNameTRONQ} | sed 's/ /\\\ /g'`
length_month=$((${numyear}*12+${numday}/30))

echo "runtime=${runtime_y}_${runtime_d}"
echo "ictime=${fictime_y}_${fictime_d}"

mode=$2 #1=compile 2=deploye other=launch 
debug=$3

if [ ${numyear} -ge 1 ]; then
  periode=1
else
  periode=$(( (${runtime_d}/${numday})+1 ))
fi

#go in the experiment directory
cd ${Rundir}/expdir/${texp}/${exp}/

#create scratch directory
mkdir -p ${scratchdir}/${texp}

#launch/compile/deploye loveclim
cd ${Rundir}/expdir/ref
if [ ${mode} -eq 1 ]; then
  echo "######################################"
  echo "###### Launch in comp/run mode #######"
  echo "######################################"
  echo "./comp_run-emic_loveclim -l ${texp}/${exp} -s ${ictime_y} -a ${ictime_d} -n ${numyear} -i ${numday} -r ${numsave_y} -q ${numsave_d} -c 1 -g ${scenGHG} -t ${scenTSI} -v ${scenVolc} -e ${scenVeget} -z ${scenfwf} -k ${scentopo} -p ${scenimsk} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}"
  ./comp_run-emic_loveclim -l ${texp}/${exp} -s ${ictime_y} -a ${ictime_d} -n ${numyear} -i ${numday} -r ${numsave_y} -q ${numsave_d} -c 1 -g ${scenGHG} -t ${scenTSI} -v ${scenVolc} -e ${scenVeget} -z ${scenfwf} -k ${scentopo} -p ${scenimsk} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}
elif [ ${mode} -eq 2 ]; then
  echo "##########################################"
  echo "##### Launch in comp/deployment mode #####"
  echo "##########################################"
  echo "./comp_norun-emic_loveclim -l ${texp}/${exp} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}"
  ./comp_norun-emic_loveclim -l ${texp}/${exp} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}
  exit
else
  echo "#################################"
  echo "##### Launch in direct mode #####"
  echo "#################################"
  echo "./comp_run-emic_loveclim -l ${texp}/${exp} -s ${ictime_y} -a ${ictime_d} -n ${numyear} -i ${numday} -r ${numsave_y} -q ${numsave_d} -c 0 -g ${scenGHG} -t ${scenTSI} -v ${scenVolc} -e ${scenVeget} -z ${scenfwf} -k ${scentopo} -p ${scenimsk} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}"
  ./comp_run-emic_loveclim -l ${texp}/${exp} -s ${ictime_y} -a ${ictime_d} -n ${numyear} -i ${numday} -r ${numsave_y} -q ${numsave_d} -c 0 -g ${scenGHG} -t ${scenTSI} -v ${scenVolc} -e ${scenVeget} -z ${scenfwf} -k ${scentopo} -p ${scenimsk} -d ${loveclimdir} -w ${Rundir}/expdir -o ${scratchdir}
fi

echo " ######################################"
echo " #### save result on masse storage ####"
echo " ######################################"
cd ${scratchdir}/${texp}/${exp}
${Rundir}/expdir/ref/save_loveclim ${paramdir} ${exp} ${fruntime_y}_${fruntime_d} ${fictime_y}_${fictime_d} ${mode}
cd ${scratchdir}/${texp}
if [ ${debug} -ne 1 ]; then rm -rf ${scratchdir}/${texp}/${exp}; fi

echo "/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/"
