      program graph

*-----------------------------------
!write a Netcdf file to be read by grads
!mts=beginning of the average
!mte=end of the average
*-----------------------------------

      implicit none

      character*128 ainput,infile,outfile
      integer numdat,mx,my,mz,mt,i,j,k,t,Ierro,NF_REDEF,NF_ENDDEF
      integer indlat,indlon,indlev,l,mx2
      real*4, dimension(:,:,:), allocatable :: tt,tt2
      real*4, dimension(:), allocatable :: alons,alats,it,plevs
      real*4, dimension(3) :: plevsU3,plevsT3
      real*4, dimension(4) :: plevsT4
      real*4, dimension(20) :: plevsOC
      real*4, dimension(22) :: plevsOC2
      real*4 lon1,dx,lat1,dy,missval
      integer,parameter :: un=1
      integer MX_var,NdimNC
      
      include 'netCDF_def.inc'

      call inputt(5,numdat)

       
      infile= ainput()
      outfile= ainput()

      fnamNC=outfile
      tit_NC='titre'
      NvatNC(:) = 2
      NAMrat(:) = 'actual_range'

      write(*,*)'creation du fichier NetCDF pour grads (graph)'
      write(*,*)'input file = ',TRIM(infile)
      write(*,*)'output file = ',TRIM(outfile)

      open(10,file=infile,status='old',form='unformatted')
      read(10) mx,my,mz,mt,lon1,dx,lat1,dy,MX_var,missval
      write(*,*) mx,my,mz,mt,lon1,dx,lat1,dy,MX_var,missval
      mx2=mx

      allocate(nameNC (1:MX_var))
      allocate(SdimNC (1:4,1:MX_var))
      allocate(unitNC (1:MX_var))
      allocate(lnamNC (1:MX_var))


      read(10)(nameNC(i),i=1,MX_var)
c     write(*,*)(i,nameNC(i),i=1,MX_var)
      read(10)(lnamNC(i),i=1,MX_var)
      read(10)(unitNC(i),i=1,MX_var)

       SdimNC(:,:) = '-'
        
       if (mx2.gt.1) SdimNC(1,:) = 'longitude' 
       if (my.gt.1) SdimNC(2,:) = 'latitude'
       if (mz.gt.1) SdimNC(3,:) = 'depth'
       SdimNC(1,:) = 'longitude'
       SdimNC(2,:) = 'latitude'
       SdimNC(3,:) = 'depth'
       SdimNC(4,:) = 'time'


      MXdim=mx2
      if(MXdim.lt.my) MXdim=my
      if(MXdim.lt.mz) MXdim=mz
      if(MXdim.lt.mt) MXdim=mt

      NdimNC=0
      if(mx2.gt.1)NdimNC=NdimNC+1
      if(my.gt.1)NdimNC=NdimNC+1
      if(mz.gt.1)NdimNC=NdimNC+1
      NdimNC=3 

      
      allocate(tt2 (1:mx2,1:my,1:mz))
      allocate(tt (1:mx,1:my,1:mz))
      allocate(alons(1:mx2))
      allocate(alats(1:my))
      allocate(it(1:mt))
      allocate(plevs(1:mz))
      allocate(VALdim(MXdim,0:NdimNC))
      allocate(nDFdim(0:NdimNC))
      allocate(NAMdim(0:NdimNC))
      allocate(UNIdim(0:NdimNC))

      plevs(:)=plevsOC(:) 
      do i=1,MX_var
        if(nameNC(i).eq.'tair') plevs(:)=plevsT4(:)
        if(nameNC(i).eq.'geopg') plevs(:)=plevsU3(:)
        if(nameNC(i).eq.'moc') plevs(:)=plevsOC2(:)
      enddo

c---Time
       include 'dimensions.inc'

       UNIdim(:)  = '-'
       nDFdim(:)  = 0
       NAMdim(:)  = '-'
       VALdim(:,:)= 0.

       UNIdim(0)  = 'years since 0001-01-01 00:00:00'
       nDFdim(0)  = mt
       NAMdim(0)  = 'time'
       do i=1,mt
         VALdim(i,0)= it(i)
       enddo

c-Lat and lon      

c     if (my.gt.1) then 
       UNIdim(2) = 'degrees_north'
       nDFdim(2) =  my
       NAMdim(2) = 'latitude'
       do i=1,my
          VALdim(i,2)= alats(i)
       enddo
c     endif

c     if (mx2.gt.1) then 
       UNIdim(1) = 'degrees_east'
       nDFdim(1) =  mx2
       NAMdim(1) = 'longitude'
       do i=1,mx2
          VALdim(i,1)= alons(i)
       enddo
c     endif

c-Profondeur      
c     if (mz.gt.1) then
       UNIdim(3) = 'm'
       nDFdim(3) =  mz
       NAMdim(3) = 'depth'
       do i=1,mz
          VALdim(i,3)= plevs(i)
       enddo
c     endif 

      NtotNC=MX_var

      CALL UNscreate (fnamNC,tit_NC,
     &                  NdimNC,nDFdim, MXdim,
     &                  NAMdim,UNIdim, VALdim,
     &                  MX_var,NtotNC, nameNC,
     &                  SdimNC,unitNC, lnamNC,
     &                  NattNC,NAMrat, NvatNC,
     &                  ID__nc)

c     filedimdef(ID__nc,"time",-1,True)
      CALL UNwcatt(ID__nc,'time','time_origin','01-JAN-0001 00:00:00')
      CALL UNwcatt(ID__nc,'latitude','axis','Y')
      CALL UNwcatt(ID__nc,'longitude','axis','X')
      CALL UNwcatt(ID__nc,'depth','axis','Z')

      do l=1,MX_var
        Ierro=NF_REDEF(ID__nc)
        CALL UNwratt(ID__nc,nameNC(l),'_FillValue',1,missval)
        Ierro=NF_ENDDEF(ID__nc)
      enddo

      do l=1,MX_var
      do t=1,mt
       do i=1,mx ; do j=1,my ; do k=1,mz
         read(10) tt(i,j,k)
       enddo     ; enddo     ; enddo
c      if (mx2.eq.mx) then
c       tt2(:,:,:)=tt(:,:,:)
c      else
c       do i=1,mx2 
c         tt2(i,:,:)=tt(1,:,:)
c       enddo  
c      endif

c         CALL UNwrite(ID__nc,nameNC(l),t,mx2,my,mz,tt2)
          CALL UNwrite(ID__nc,nameNC(l),t,mx2,my,mz,tt)
      enddo
      enddo
      close(10)


      CALL UNclose(ID__nc) 
      write(*,*)'fin de graph'
      write(*,*)'--------------------------------------'

      end program


