c23456789012345678901234567890123456789012345678901234567890123456789012
      subroutine inputt(ifile,numdat)
c-----------------------------------------------------------------------
c     This routine reads one line from unit ifile or in case unit is 
c     standard input 5, it checks for command line arguments and  
c     if there are any does not read from standard input.
c
c-----------------------------------------------------------------------
      implicit none
      
      integer            iposit(66),ndata,idata,ifile,numdat
      integer            maxl
      parameter          (maxl=1024)
      integer            iargc
!      external           iargc
      character*(maxl) line
      
      common /linput/ line
      common /lposit/ iposit,ndata,idata
      
      numdat=0
      if ( iargc().gt.0.and.ifile.eq.5 ) then
        ndata = -1
        numdat = iargc()
      else
        read(ifile,11,end=999) line
11      format(a)
        if (line.eq.'') return
        ndata = 0
        idata = 0
      
10      continue
          idata = idata + 1
          if (idata.gt.maxl) then
            idata = 0
            return
          end if
          if (line(idata:idata).ne.' ') then
            ndata = ndata + 1
            numdat = ndata
            iposit(ndata) = idata
20          idata = idata + 1
            if (idata.gt.maxl) then
              idata = 0
              return
            end if
            if (line(idata:idata).ne.' ') goto 20
          end if               
        goto 10
      endif
999   continue

      end
      
c23456789012345678901234567890123456789012345678901234567890123456789012
      function iinput()
c-----------------------------------------------------------------------
c     this routine reads an integer from line (ndata > 0) or from 
c     command line arguments (ndata < 0)
c-----------------------------------------------------------------------
 
      implicit none
      
      integer          iinput,iposit(66),ndata,idata,ibegin,iend,nchar
      integer          maxl
      parameter        (maxl=1024)
      character*(maxl) line

      
      common /linput/ line
      common /lposit/ iposit,ndata,idata
      
      if ( ndata.lt.0 ) then
        call getarg(-ndata,line)
        ndata = ndata - 1
        read(line,*)iinput
      else
        idata = idata + 1
        if (idata.gt.ndata) then
          call error('insufficient data on input line ',34)
        endif
        ibegin = iposit(idata)
        if (idata.lt.ndata) then
           iend = iposit(idata+1) - 1
        else
          iend=maxl
10        continue
          if (line(iend:iend).eq.' '.and.iend.gt.ibegin) then
            iend=iend-1
            goto 10
          endif
        end if
        nchar = iend-ibegin+1
        if (nchar.eq.1) read(line(ibegin:iend),'(i1)') iinput
        if (nchar.eq.2) read(line(ibegin:iend),'(i2)') iinput
        if (nchar.eq.3) read(line(ibegin:iend),'(i3)') iinput
        if (nchar.eq.4) read(line(ibegin:iend),'(i4)') iinput
        if (nchar.eq.5) read(line(ibegin:iend),'(i5)') iinput
        if (nchar.eq.6) read(line(ibegin:iend),'(i6)') iinput
        if (nchar.eq.7) read(line(ibegin:iend),'(i7)') iinput
        if (nchar.eq.8) read(line(ibegin:iend),'(i8)') iinput
        if (nchar.eq.9) read(line(ibegin:iend),'(i9)') iinput
        if (nchar.eq.10) read(line(ibegin:iend),'(i10)') iinput
        if (nchar.lt.1.or.nchar.gt.10) then
          call error('error reading integer in iinput ',32)
        endif
      endif
      return
      end
      
c23456789012345678901234567890123456789012345678901234567890123456789012
      function finput()
c-----------------------------------------------------------------------
c     this routine reads a floating point number from line (ndata > 0) 
c     or from command line arguments (ndata < 0)
c-----------------------------------------------------------------------
      implicit none
      
      real             finput
      integer          iposit(66),ndata,idata,ibegin,iend,nchar
      integer          maxl
      parameter        (maxl=1024)
      character*(maxl) line
      
      common /linput/ line
      common /lposit/ iposit,ndata,idata
      
      if ( ndata.lt.0 ) then
        call getarg(-ndata,line)
        ndata = ndata - 1
        read(line,*)finput
      else
        idata = idata + 1
        if (idata.gt.ndata) then
          call error('insufficient data on input line in finput ',42)
        endif
        ibegin = iposit(idata)
        if (idata.lt.ndata) then
           iend = iposit(idata+1) - 1
        else
          iend=maxl
10        continue
          if (line(iend:iend).eq.' '.and.iend.gt.ibegin) then
            iend=iend-1
            goto 10
          endif
        end if
        nchar = iend-ibegin+1
        read(line(ibegin:iend),*) finput
      endif
      return
      end
      
c23456789012345678901234567890123456789012345678901234567890123456789012
      function ainput()
      implicit none
      
      integer          iposit(66),ndata,idata,ibegin,iend
      integer          maxl
      parameter        (maxl=1024)
      character*(maxl) line
      character*128    ainput
      
      common /linput/ line
      common /lposit/ iposit,ndata,idata
      
      if ( ndata.lt.0 ) then
        call getarg(-ndata,line)
        ndata = ndata - 1
        ainput = line
      else
        idata = idata + 1
        if (idata.gt.ndata) then
          call error('insufficient data on input line in ainput ',42)
        endif
        ibegin = iposit(idata)
        if (idata.lt.ndata) then
          iend = iposit(idata+1) - 1
        else
          iend=maxl
10        continue
          if (line(iend:iend).eq.' '.and.iend.gt.ibegin) then
            iend=iend-1
            goto 10
          endif
        end if
        iend = min(iend,ibegin+48)
        iend = min(iend,maxl)
        ainput = '                                                '
        ainput(1:iend-ibegin+1) = line(ibegin:iend)
      endif
      return
      end
      
c23456789012345678901234567890123456789012345678901234567890123456789012
      integer function length(string)
      
      implicit none
      
      character string*(*)
      integer   i
      
      do i=len(string),1,-1
        if (string(i:i).ne.' ' ) goto 100
      enddo
      
*	Fortran abhors empty strings

      length = 1
      return
 100  continue
      length = i
      return
      end
      
c23456789012345678901234567890123456789012345678901234567890123456789012      
      subroutine error(myline)
      implicit none
      
      character     myline*(*)

      write(*,*)
      write(*,*) '***** Error: ',myline
      call abort
      end 
      
c23456789012345678901234567890123456789012345678901234567890123456789012      
      subroutine checkfile(fname)
      implicit none
      
      character*128 fname
      logical       ex
      
      inquire(file=fname,exist=ex)

      if (.not.ex) call error('Cannot find file '//fname)
      
      end 
      
