      program read_veget1D

!     implicit double precision (a-h,o-z)
      integer, parameter :: imax = 244
      integer, parameter :: jmax = 130
      integer, parameter :: ivar = 19
      integer, parameter :: itmax = 250
      integer, parameter  :: one=1
      character*30 fmt
      character*40 ccfilr,ccfilw,ainput
      character*80 line, titf1
      character*30, dimension(ivar) :: varname,uname
      character*50, dimension(ivar) :: lname

      integer im,jm,km
      real*4  val(imax,jmax,ivar,itmax)
      dimension  titf1(ivar)


      data varname / 'tfrac', 'gfrac   ', 'dfrac  ', 'nfrac',
     &              'lait   ', 'laig   ', 'alb',
     &              'temp ', 'gdd0', 'prc', 'prcveg ',
     &              'uptake', 'stock' , 'b1' ,
     &              'b2' , 'b3' ,'b4' ,'NPP',
     &               'cfrac'  /
      data lname / 'tree_fraction','grass_fraction','desert_fraction',
     &             'needle_tree_fraction','tree_leaf_area_index',
     &             'grass_leaf_area_index','vegetation_albedo',
     &             'surface_temperature','Annual_gdd0_index',
     &             'precipitation',
     &             'reduced_precipitaion','Biomass_carbon_uptake',
     &             'Biomass_carbon_stock','leaves_biomass_carbon_stock',
     &             'stems_root_biomass_stock','litter_carbon_stock',
     &             'mortmass_and_soil_organic_matter_carbon_stock',
     &             'net_primary_productivity','ice_sheet_fraction' /

      data uname / '%','%','%','%','1','1','%','°C','10^-3','m/y','m/y'
     &             ,'GtC/y','GtC','GtC','GtC','GtC'
     &             ,'GtC','GtC/y','%' /

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  1 ) Entrees au clavier .
c-----------------------------------------------------------------------

      call inputt(5,numdat)

      ccfilr=ainput()
      ccfilw= ainput()
      write(*,*)'read vegetation model output (read_veget1D.f)'
      write(*,*)'input file = ',TRIM(ccfilr)
      write(*,*)'output file = ',TRIM(ccfilw)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  2 ) Lecture des donnees .                                           |
c-----------------------------------------------------------------------

c--READ DATA.


      open(10, file = TRIM(ccfilr), status = 'old')
c--Lecture de l'en-tete :
      read(10,'(A30,A)') fmt, line
      read(line,*) spv, im, km, itime, nfrc
      read(10,*) xi1, dxi, yj1, dyj, zk1, dzk, ntyp
      if (yj1.ne.-85.76) then
        write(*,*) 'change yj1= ',yj1,' to yj1= -85.76'
        yj1=-85.76
      endif
      if (xi1.ne.0.) then
        write(*,*) 'change xi1= ',xi1,' to xi1= 0.'
        xi1=0.
      endif
      if (dyj.ne.5.54) then
       write(*,*) 'change dyj= ',dyj,' to dyj=5.54'
       dyj=5.54
      endif


c***** change HR
      jm=1
      jj1=1
      jj2=1
      jj3=1
c*****
!     val(:,:,:,:)=spv

      do 251 it=1,itime

c--lecture des donnees du niveau "k" :
      read(10,*)
      read(10,*)
!     read(10,'(A)') titf1(k)
!     read(10,'(A)') titf1(k)
c***HR
        do 250 k=1,km
c***
          if (nfrc.ge.0) then
          do 210 j=jj1,jj2,jj3
            read(10,fmt) (val(i,j,k,it),i=1,im)
 210      continue
        else
          do 220 iis = 1,im,-nfrc
            iie = min(im,iis-nfrc-1)
            do 215 j=jj1,jj2,jj3
              read(10,fmt) (val(i,j,k,it),i=iis,iie)
 215        continue
 220      continue
        endif
c--fin de la lecture du niveau k .
 250    continue
c***HR
        read(10,*)
c***
 251  continue
      jm = abs(jm)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  1 ) sorties grads
c-----------------------------------------------------------------------
      open (8, FILE=TRIM(ccfilw)//'.bin', FORM='UNFORMATTED')
      write(8) one,im-1,one,itime,xi1,dxi,yj1,dyj,km,spv
      write(*,*) one,im-1,one,itime,xi1,dxi,yj1,dyj,km,spv
      write(8) (varname(i),i=1,km)
      write(8) (lname(i),i=1,km)
      write(8) (uname(i),i=1,km)

      do 20 k=1,km
        do 30 it=1,itime
           do j=1,one ; do i=2,im
              write(8) val(i,j,k,it)
           enddo     ; enddo
  30   continue
  20   continue

      close(8)
      jm=64
      open (8, FILE=TRIM(ccfilw)//'GL.bin', FORM='UNFORMATTED')
      write(8) jm,one,one,itime,xi1,dxi,yj1,dyj,km,spv
      write(8) (varname(i),i=1,km)
      write(8) (lname(i),i=1,km)
      write(8) (uname(i),i=1,km)

      do 40 k=1,km
        do 50 it=1,itime
         do j=1,jm; do i=1,one
           if(j.gt.1) val(i,j,k,it)=spv 
           write(8) val(i,j,k,it)
         enddo ; enddo
 50     continue
 40    continue

      write(*,*)'fin de read_veget1D.f'
      write(*,*)'-------------------------------------------'
      end
