      program read_veget2D

      include 'netcdf.inc'

!     implicit double precision (a-h,o-z)
      integer, parameter :: imax = 244
      integer, parameter :: jmax = 130
      integer, parameter :: ivar = 19
      integer, parameter :: itmax = 250
      integer, parameter  :: one=1
      character*30 fmt
      character*40 ccfilr,ccfilw,ainput
      character*80 line, titf1
      character*30, dimension(ivar) :: varname,uname
      character*50, dimension(ivar) :: lname

      real*4  val(imax,jmax,ivar,itmax)
      dimension  titf1(ivar)

!-------------------------------------------------------------
      integer*4  ncid, ncidd, status    ! file control
      integer*4  dimid_lon    ! dimension id control
      integer*4  varid_lon    ! variable id control
      integer*4  dimid_lat    ! dimension id control
      integer*4  varid_lat    ! variable id control
      integer*4  dimid_time   ! dimension id control
      integer*4  varid_time   ! variable id control
      integer*4  varid_gdd    ! variable id control
!-------------------------------------------------------------
      integer*4          :: start(10)
      integer*4          :: count(10)
      integer*4          :: dd(10)
      integer*4          :: today(3), now(3)
      integer            :: dimids(10)! allow up to 10 dimensions
      integer            :: dimid, xtype
      character(len=31)  :: dummy
!      external           :: idate
      character(len=90)  :: units,longname,convertname
      character(len=2048):: longdata
      real*4             :: rlongname(5)
      real*4, dimension(:), allocatable :: alons,alats,it 
      real*4, dimension(:,:,:), allocatable    ::  gdd
!-------------------------------------------------------------

      data varname / 'tfrac', 'gfrac   ', 'dfrac  ', 'nfrac',
     &              'lait   ', 'laig   ', 'alb',
     &              'temp ', 'gdd0', 'prc', 'prcveg ',
     &              'uptake', 'stock' , 'b1' ,
     &              'b2' , 'b3' ,'b4' ,'NPP',
     &               'cfrac'  /
      data lname / 'tree_fraction','grass_fraction','desert_fraction',
     &             'needle_tree_fraction','tree_leaf_area_index',
     &             'grass_leaf_area_index','vegetation_albedo',
     &             'surface_temperature','Annual_gdd0_index',
     &             'precipitation',
     &             'reduced_precipitaion','Biomass_carbon_uptake',
     &             'Biomass_carbon_stock','leaves_biomass_carbon_stock',
     &             'stems_root_biomass_stock','litter_carbon_stock',
     &             'mortmass_and_soil_organic_matter_carbon_stock',
     &             'net_primary_productivity','ice_sheet_fraction' /

      data uname / '%','%','%','%','1','1','%','°C','10^-3','m/y','m/y' 
     &             ,'kgC/y/m^2','kgC/m^2','kgC/m^2','kgC/m^2','kgC/m^2'
     &             ,'kgC/m^2','kgC/y/m^2','%' /
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  1 ) Entrees 
c-----------------------------------------------------------------------

      call inputt(5,numdat)

      ccfilr=ainput()
      ccfilw= ainput()

      write(*,*)'read vegetation model output (read_veget2D.f)'
      write(*,*)'input file = ',TRIM(ccfilr)
      write(*,*)'output file = ',TRIM(ccfilw)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  2 ) Lecture des donnees .                                           |
c-----------------------------------------------------------------------

c--READ DATA.


      open(10, file = TRIM(ccfilr), status = 'old')
c--Lecture de l'en-tete :
      read(10,'(A30,A)') fmt, line
      read(line,*) spv, im, jm, km, nfrc
      read(10,*) xi1, dxi, yj1, dyj, zk1, dzk, ntyp
      if (yj1.ne.-85.76) then
       write(*,*) 'change yj1= ',yj1,' to yj1= -85.76' 
       yj1=-85.76
      endif
      if (xi1.ne.0.) then
       write(*,*) 'change xi1= ',xi1,' to xi1= 0.'
       xi1=0.
      endif
      if (dyj.ne.5.54) then
       write(*,*) 'change dyj= ',dyj,' to dyj=5.54'
       dyj=5.54
      endif 
      jj1 = max(1,-jm)
      jj2 = max(jm,1)
      jj3 = sign(1,jm)

c--Initialisation :
      do 200 itt=1,itmax
      do 200 k=1,ivar
       do 200 j=1,jmax
        do 200 i=1,imax
         val(i,j,k,itt) = spv
 200  continue

      itime=abs(km)/ivar
      km=ivar

      do 251 itt=1,itime
      do 250 k=1,ivar
c--lecture des donnees du niveau "k" :
      read(10,'(A)') titf1(k)
      read(10,'(A)') titf1(k)

      if (nfrc.ge.0) then
        do 210 j=jj1,jj2,jj3
          read(10,fmt) (val(i,j,k,itt),i=1,im)
 210    continue
        read(10,*)
      else
        do 220 iis = 1,im,-nfrc
          iie = min(im,iis-nfrc-1)
          do 215 j=jj1,jj2,jj3
            read(10,fmt) (val(i,j,k,itt),i=iis,iie)
            write(*,*) (val(i,j,k,itt),i=iis,iie)
 215      continue
          read(10,*)
 220    continue
      endif
c--fin de la lecture du niveau k .
 250  continue
 251  continue
      jm = abs(jm)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  1 ) sorties grads
c-----------------------------------------------------------------------
      open (8, FILE=TRIM(ccfilw)//'.bin', FORM='UNFORMATTED')  
      write(8) im,jm,one,itime,xi1,dxi,yj1,dyj,ivar,spv
      write(*,*) im,jm,one,itime,xi1,dxi,yj1,dyj,ivar,spv
      write(8) (varname(i),i=1,ivar)
      write(8) (lname(i),i=1,ivar)
      write(8) (uname(i),i=1,ivar)

       
      do 20 k=1,ivar
        do 30 itt=1,itime
          do i=1,im ; do j=1,jm
             write(8) val(i,j,k,itt)
          enddo     ; enddo
 30   continue
 20   continue      

!----------------------------------------------------

! Open a netCDF file
      status=nf_create('gdd.nc',nf_clobber,ncidd)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
 221  format(a)
 222  format(a,a)

! Define the dimensions
      status=NF_DEF_DIM(ncidd,'lon',im,dimid_lon)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_DEF_DIM(ncidd,'lat',jm,dimid_lat)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_DEF_DIM(ncidd,'time',NF_UNLIMITED,dimid_time)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)

! Define the variables (include the variables giving the dim. values)

! Definition of lon
      dd(:)=0
      dd(           1 )=dimid_lon
      status=NF_DEF_VAR(ncidd,'lon',NF_FLOAT,   1,dd,varid_lon)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Define the attributes of lon
      units='degrees_east'
      longname="Longitude"
      dimid=0
      status=NF_PUT_ATT_TEXT(ncidd,varid_lon,
     &                         'units',len_trim(units),trim(units))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_TEXT(ncidd,varid_lon,
     &               'long_name',len_trim(longname),trim(longname))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Definition of lat
      dd(:)=0
      dd(           1 )=dimid_lat
      status=NF_DEF_VAR(ncidd,'lat',NF_FLOAT,   1,dd,varid_lat)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Define the attributes of lat
      units='degrees_north'
      longname="Latitude"
      dimid=0
      status=NF_PUT_ATT_TEXT(ncidd,varid_lat,
     &                         'units',len_trim(units),trim(units))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_TEXT(ncidd,varid_lat,
     &               'long_name',len_trim(longname),trim(longname))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Definition of time
      dd(:)=0
      dd(           1 )=dimid_time
      status=NF_DEF_VAR(ncidd,'time',NF_FLOAT,   1,dd,varid_time)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Define the attributes of time
      units='yr'
      longname="Model Time"
      dimid=0
      status=NF_PUT_ATT_TEXT(ncidd,varid_time,
     &                         'units',len_trim(units),trim(units))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_TEXT(ncidd,varid_time,
     &               'long_name',len_trim(longname),trim(longname))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Definition of gdd
      dd(:)=0
      dd(           1 )=dimid_lon
      dd(           2 )=dimid_lat
      dd(           3 )=dimid_time
      status=NF_DEF_VAR(ncidd,'gdd',NF_FLOAT,   3,dd,varid_gdd)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
! Define the attributes of gdd
      units='Celsius'
      longname="growing degree days above 0"
      dimid=0
      status=NF_PUT_ATT_TEXT(ncidd,varid_gdd,
     &                         'units',len_trim(units),trim(units))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_TEXT(ncidd,varid_gdd,
     &               'long_name',len_trim(longname),trim(longname))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_REAL(ncidd,varid_gdd,
     &               'missing_value',NF_FLOAT,1,spv)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)

!   Write the global attributes
      units='2D Map - Growing degree days above 0'
      status=NF_PUT_ATT_TEXT(ncidd,NF_GLOBAL,'title',
     &                           len_trim(units),trim(units))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      status=NF_PUT_ATT_TEXT(ncidd,NF_GLOBAL,'institution',
     &                    30,'UCL-ASTR (Pierre-Yves Barriat)')
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      call idate(today)   ! today(1)=day, (2)=month, (3)=year
!      call itime(now)     ! now(1)=hour, (2)=minute, (3)=second
      longdata=''
      write(longdata,999) today(1), today(2), (2000+today(3))!, now
  999 format(i2.2,'/',i2.2,'/',i4.4,' ',i2.2,':',i2.2,':',i2.2)
      status=NF_PUT_ATT_TEXT(ncidd,NF_GLOBAL,'history',
     &                                    (31+len_trim(longdata)),
     &           'Created by read_veget2D (2010) - '//trim(longdata))
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)

! Change mode of netCDF operation
      status=NF_ENDDEF(ncidd)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)

! Output the values of the variables (include dimension variables)

      allocate(alons(1:im))
      allocate(alats(1:jm))
      allocate(it(1:itime))
      do i=1,itime ; it(i)= i ; enddo
      do i=1,im ; alons(i)= xi1+(i-1)*dxi ; enddo
      do i=1,jm ; alats(i)= yj1+(i-1)*dyj ; enddo

!----------------------------------------------------
!   Output data for Variable 'lon'
      start(:)=0
      count(:)=0
      start(1)=1
      count(1)=im
      status=NF_PUT_VARA_REAL(ncidd,varid_lon,start,count,alons)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
!----------------------------------------------------
!   Output data for Variable 'lat'
      start(:)=0
      count(:)=0
      start(1)=1
      count(1)=jm
      status=NF_PUT_VARA_REAL(ncidd,varid_lat,start,count,alats)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
!----------------------------------------------------
!   Output data for Variable 'time'
      start(:)=0
      count(:)=0
      start(1)=1
      count(1)=itime
      status=NF_PUT_VARA_REAL(ncidd,varid_time,start,count,it)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
!----------------------------------------------------
!   Output data for Variable 'gdd0'
      start(:)=0
      count(:)=0
      start(1)=1
      count(1)=im
      start(2)=1
      count(2)=jm
      start(3)=1
      count(3)=itime
      allocate(gdd (im,jm,itime))
      do i=1,im
         do j=1,jm
            do itt=1,itime
               gdd(i,j,itt)=val(i,j,9,itt)
            end do
         end do
      end do
      status=NF_PUT_VARA_REAL(ncidd,varid_gdd,start,count,gdd)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)
      deallocate(gdd)
!----------------------------------------------------
! Close the file up
      status=NF_CLOSE(ncidd)
      if ( status/=nf_noerr ) write (*,*) nf_strerror(status)

      write(*,*)'fin de read_veget2D.f'
      write(*,*)'-------------------------------------------'
      end
