!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PROGRAM crop_grille_ecbilt
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  USE NETCDF

          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! DECLARATION DES VARIABLES !!!!
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

         implicit none
         !variable pour l'ouverture ecriture du netcdf
         character(256) :: filenameIn, filenameOut, filenameOut2
         integer :: intputID, unlimDimID, nbDim, nbvarDim, varID, dimtype, ID
         integer, dimension(nf90_max_var_dims) :: varDimID, dimSize
         character(nf90_max_name), dimension(nf90_max_var_dims) :: dimName

         !variable pour le calcul des moyennes, etc...
         real*8, dimension(:), allocatable :: lon, lat, time, ValueVar
         real*8, dimension(:,:,:,:), allocatable :: ValueOneYear

         !variable d'index qui servent à tout 
         integer :: i, iyr, iLatMin, iLatMax, Nty

         !variables pour le changement de grille
         real*8 compt,x1,y1,x2,y2,xi,yi
         real*8 farea(64,32,1)
         real*8 data_crop(720,360)
         integer nlat,nlon,ilat,jlong,clat,clon
         
         !variables pour l'interpolation
         real*8 fareaInt(64,32,1)
         real*8 alpha,tanalpha
         integer :: tps
         
         !variable ndfor et i0dfor
         integer :: ndfor,i0dfor  


         !variables pour l'écriture du Netcdf
         integer :: outputID
         integer :: outdimid, outvarid
         real*8, dimension(:), allocatable :: lon_ecbilt, lat_ecbilt
         integer, dimension(:), allocatable :: iyr_tab, iyr_tab2
         real*8 Intermediaire(32,64), Intermediaire2(32,64)
  


          !!!!!!!!!!!!!!!
          !!!! USAGE !!!!
          !!!!!!!!!!!!!!!

  if(iargc().eq.3) then
    call getarg(1,filenameIn)
    call getarg(2,filenameOut)
    call getarg(3,filenameOut2)
  else
    write(*,'(A)') "Usage: ./crop_grille_ecbilt [input.nc] [output.dat] [output.nc]"
    stop
  endif


          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! OUVRE LE FICHIER OU SERONT STOCKEES LES FRACTIONS DE CROP MISES A L'ECHELLE DE LA GRILLE D'ECBILT !!!!
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
  open(1,file=filenameOut,form='unformatted')
  ndfor=1992!  Nombre d'enregistrement dans le scénario --> = nombre d'années.
!  ndfor=1143!  Nombre d'enregistrement dans le scénario --> = nombre d'années.
  i0dfor=0!    year-1 of first available data in VEGET0_1992.dat 
!  i0dfor=849!    year-1 of first available data in VEGET0_1992.dat 
  write(1)ndfor,i0dfor!  Ajoute ndfor et i0dfor dans l'en-tête


          !!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! OPEN INPUT FILE !!!!    --> OUVRE LE NETCDF
          !!!!!!!!!!!!!!!!!!!!!!!!!


  call check(nf90_open(filenameIn, nf90_nowrite, intputID))
  call check(nf90_inquire(intputID, nbDim, unlimitedDimId = unlimDimID))

  call check(nf90_inq_varid(intputID, "vegfract", varID))
  call check(nf90_inquire_variable(intputID, varID, ndims = nbvarDim, dimids = varDimID))

  do i=1,nbvarDim
    call check(nf90_inquire_dimension(intputID, varDimID(i), name = dimName(i), len = dimSize(i)))
    call check(nf90_inq_varid(intputID, dimName(i), ID))
    call check(nf90_inquire_variable(intputID, ID, xtype = dimtype))
    write(*,*) trim(dimName(i)), " (size=", dimSize(i), ") "

    if(dimName(i).eq."longitude") then
      allocate(lon(dimSize(i)))
      call check(nf90_get_var(intputID, ID, lon, start = (/ 1 /), count = (/ dimSize(i) /)))
    endif
    
    if(dimName(i).eq."latitude") then
      allocate(lat(dimSize(i)))
      call check(nf90_get_var(intputID, ID, lat, start = (/ 1 /), count = (/ dimSize(i) /)))
    endif

    if(dimName(i).eq."time") then
      allocate(time(dimSize(i)))
      call check(nf90_get_var(intputID, ID, time, start = (/ 1 /), count = (/ dimSize(i) /)))
    endif
  enddo



        	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!     CREE NETCDF POUR STOCKER LES RESULTATS      !!!!
					!!!!     CA SERT A POUVOIR VERIFIER SI CE QUI EST    !!!!
					!!!!     INSCRIT DANS LE BINAIRE EST CORRECT         !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !write target file
  call check(nf90_create(filenameOut2, nf90_clobber, outputID))
  

  !define dimension
  call check(nf90_def_dim(outputID, "lon", 64, outdimid))
  call check(nf90_def_var(outputID, "lon", NF90_FLOAT, (/ 1 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "longitude coordinate"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "longitude"))
  call check(nf90_put_att(outputID, outvarid, "units", "degrees_east"))
  call check(nf90_put_att(outputID, outvarid, "axis", "X"))

  call check(nf90_def_dim(outputID, "lat", 32, outdimid))
  call check(nf90_def_var(outputID, "lat", NF90_FLOAT, (/ 2 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "latitude coordinate"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "latitude"))
  call check(nf90_put_att(outputID, outvarid, "units", "degrees_north"))
  call check(nf90_put_att(outputID, outvarid, "axis", "Y"))
  !NF90_UNLIMITED
  call check(nf90_def_dim(outputID, "time", NF90_UNLIMITED, outdimid))
  call check(nf90_def_var(outputID, "time", NF90_FLOAT, (/ 3 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "time"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "time"))
  call check(nf90_put_att(outputID, outvarid, "units", "years since 0001-01-01 00:00:00"))
  call check(nf90_put_att(outputID, outvarid, "time_origin", "01-JAN-0001 00:00:00"))

  !define variable
  call check(nf90_def_var(outputID, "vegfrac", NF90_FLOAT, (/ 1, 2, 3 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "fraction de culture par maille"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "fraction_culture"))
  call check(nf90_put_att(outputID, outvarid, "units", "%"))
  call check(nf90_put_att(outputID, outvarid, "missing_value", real(-99.99)))

  !finish the configuration of the output file
  call check(nf90_enddef(outputID))



          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! LECTURE DU NETCDF ET MISE DANS LA BONNE GRILLE !!!!  
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! --> On passe d'une grille de "360 x 720" à une grille de "32 x 64"

  nlat=32
  nlon=64

  allocate(lat_ecbilt(nlat))
  allocate(lon_ecbilt(nlon))
  allocate(iyr_tab(1))
  allocate(iyr_tab2(1))
  allocate(ValueVar(size(lon)*size(lat)))
  allocate(ValueOneYear(size(lon),size(lat),1,1))
       
       
  do iyr=1,size(time)!										REALISE POUR CHAQUE ANNEE L'OPERATION    (ici, de 1 à 1993)
    !write(6,*)iyr,'/',size(time) !  										MONTRE A L'ECRAN L'ANNEE QUI EST REALISEE

    call check(nf90_get_var(intputID, varID, ValueVar, start = (/ 1, 1, 1, iyr /), count = (/ size(lon),size(lat),1,1 /)))
    ValueOneYear=reshape(ValueVar, (/ size(lon),size(lat),1,1 /))
    data_crop(:,:)=ValueOneYear(:,:,1,1)!						ETABLIS LA RELATION ENTRE LA MATRICE value ET LA MATRICE data_crop
    farea(:,:,1)=0.!											REMPLIR LA MATRICE farea DE 0


					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE LES BORNES DE CHACUNE DES     !!!!
					!!!!         CELLULES DE LA GRILLE D'ECBILT          !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
    do clat=1,nlat!											POUR LES LATITUDES ALLANT DE 1 à 32
      y1=-90+((clat-1)*5.625)!						(x1,x2,y1,y2)
      y2=y1+5.625
      lat_ecbilt(clat)=y1+5.625/2.
      
      do clon=1,nlon!										POUR LES LONGITUDES ALLANT DE 1 à 64
        compt=0.!											ON INITIALISE LE COMPTEUR à 0
        x1=-2.81+((clon-1)*5.625)!						ON CALCULE LES BORNES DE LA CELLULES DE LA MAILLE
        x2=x1+5.625!									DE LA GRILLE D'ECBILT QU'ON TRAITE
        lon_ecbilt(clon)=x1+5.625/2.
        iLatMin=(clat-1)*11.25-1
        iLatMax=(clat)*11.25+1
		    if(iLatMax>360) iLatMax=360
		    if(iLatMin<1) iLatMin=1

					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE LES VALEURS QUI DOIVENT       !!!!
					!!!!    REMPLIR LES CELLULES DE LA GRILLE D'ECBILT   !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       		
        do ilat=iLatMin,iLatMax
          do jlong=1,720

            if (data_crop(jlong,ilat).gt.0.) then!   >0 pour ne pas prendre missing values
              xi=-179.25+((jlong-1)*0.5)

              if (xi.lt.-2.75) xi=xi+360
              ! yi=89.75-((ilat-1)*0.5)
              yi=lat(ilat)

              if(((xi.lt.x2).and.(xi.gt.x1)).and.((yi.lt.y2).and.(yi.gt.y1))) then
                farea(clon,clat,1)=farea(clon,clat,1)+data_crop(jlong,ilat)
                compt=compt+1
              endif

            endif
          enddo
        enddo

        if (compt.ne.0) farea(clon,clat,1)=farea(clon,clat,1)/compt
        if (compt.eq.0) farea(clon,clat,1)=-99.99
!         if (compt.ne.0) farea(clon,clat,1)=2
!         if (compt.eq.0) farea(clon,clat,1)=2
      enddo
    enddo

					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE L'INTERPOLATION ENTRE LA      !!!!
					!!!!            PREMIERE ANNEE ET L'AN 1             !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     write(*,*) iyr
     if(iyr.eq.1) then!		je fait l'interpos entre 0 et farea(clat,clon) -> 0 et 800 ans
        do tps=1, 799
          do clat=1,nlat!			POUR LES LATITUDES ALLANT DE 1 à 32
            do clon=1,nlon! 		POUR LES LONGITUDES ALLANT DE 1 à 64
               if (farea(clon,clat,iyr).gt.0.) then
                 tanalpha=farea(clon,clat,iyr)/800
                 !write(*,*) tps, clat, clon, iyr, tanalpha
                 alpha=atan(tanalpha)
                 !write(*,*) "tanalpha", tanalpha
                 fareaInt(clon,clat,1)=((farea(clon,clat,iyr))/800)*tps
!                 fareaInt(clon,clat,1)=-99.99
               else
                 fareaInt(clon,clat,1)=-99.99    
               endif
            enddo
          enddo
            
           do clat=1,nlat!			POUR LES LATITUDES ALLANT DE 1 à 32
             do clon=1,nlon! 
               Intermediaire(clat,clon)=fareaInt(clon,clat,1)
             enddo
           enddo
! 
          write(1)Intermediaire
          iyr_tab(1)=tps  
          call check(nf90_put_var(outputID, 3, iyr_tab, (/tps/), (/ 1 /))) 
          call check(nf90_put_var(outputID, outvarid, fareaInt, (/1, 1, tps/), (/64, 32, 1/)))
          write(6,*)tps,'/',(size(time))+799

         enddo
     endif 
        
           







!         
        	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!         FIN DE L'INTERPOLATION ENTRE LA         !!!!
					!!!!            PREMIERE ANNEE ET L'AN 0             !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       do clat=1,nlat!			POUR LES LATITUDES ALLANT DE 1 à 32
         do clon=1,nlon! 
            Intermediaire2(clat,clon)=farea(clon,clat,1)
         enddo
       enddo
             



!    iyr_tab2(1)=iyr      
    iyr_tab2(1)=iyr+799  
    call check(nf90_put_var(outputID, 3, iyr_tab2, (/iyr_tab2/), (/ 1 /)))    


    Nty=iyr+799      
    write(1)Intermediaire2
!    call check(nf90_put_var(outputID, outvarid, farea, (/1, 1, iyr/), (/64, 32, 1/)))
    call check(nf90_put_var(outputID, outvarid, farea, (/1, 1, Nty/), (/64, 32, 1/)))
!    call check(nf90_put_var(outputID, outvarid, Intermediaire2, (/1, 1, iyr/), (/64, 32, 1/)))
    write(6,*)iyr+799,'/',(size(time))+799
             
    !put data in lon variable
    call check(nf90_put_var(outputID, 1, lon_ecbilt, (/1/), (/64/)))
    !put data in lat variable
    call check(nf90_put_var(outputID, 2, lat_ecbilt, (/1/), (/32/)))



! 


!      if(iyr.eq.100) then!
!        deallocate(ValueVar); deallocate(ValueOneYear);
!        call check(nf90_close(intputID))
!        close(1)
!        call check(nf90_close(outputID))
!        stop
!      endif




  enddo
  deallocate(ValueVar); deallocate(ValueOneYear);
 
 
 
 
          !!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! CLOSE INPUT FILE  !!!!
          !!!!!!!!!!!!!!!!!!!!!!!!!!!

  call check(nf90_close(intputID))
  close(1)
  call check(nf90_close(outputID))

END PROGRAM crop_grille_ecbilt








SUBROUTINE check(status)
    USE NETCDF
    IMPLICIT NONE
    
    INTEGER, INTENT (IN) :: status
    if(status /= nf90_noerr) then 
      write(*,*)"Error  : ", trim(nf90_strerror(status))
      stop 
    end if
END SUBROUTINE check  













  




  !put data in time variable
 !allocate(timeAnnu(size(time)/12))
  !do i=1, size(time)/12
   ! timeAnnu(i)=i
  !enddo
  !call check(nf90_put_var(outputID, 3, timeAnnu, (/1/), (/(size(time)/12)/)))

  !put data in 6 variables
  !call check(nf90_put_var(outputID, outvarid, farea, (/1, 1, 1/), (/64, 32, (size(time)/12)/)))
