!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PROGRAM crop_grille_ecbilt
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  USE NETCDF

          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! DECLARATION DES VARIABLES !!!!
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

         implicit none
         !variable pour l'ouverture ecriture du netcdf
         character(256) :: filenameIn, filenameOut, parm
         integer :: intputID, unlimDimID, varID, ID, nbTime, Tzero

         !variable pour le calcul des moyennes, etc...
         real*8, dimension(:), allocatable :: lon, lat, time, ValueVar
         real*8, dimension(:,:,:,:), allocatable :: ValueOneYear

         !variable d'index qui servent à tout 
         integer :: iyr, iLatMin, iLatMax, Nty

         !variables pour le changement de grille
         real*8 compt,x1,y1,x2,y2,xi,yi, Vzero
         real*8 farea(64,32,1)
         real*8 data_crop(720,360)
         integer nlat,nlon,ilat,jlong,clat,clon
         
         !variables pour l'interpolation
         real*8 fareaInt(64,32,1)
         integer :: tps
         
         !variables pour l'écriture du Netcdf
         integer :: outputID
         integer :: outdimid, outvarid
         real*8, dimension(:), allocatable :: lon_ecbilt, lat_ecbilt
         integer, dimension(:), allocatable :: iyr_tab, iyr_tab2


          !!!!!!!!!!!!!!!
          !!!! USAGE !!!!
          !!!!!!!!!!!!!!!

  if(iargc().eq.4) then
    call getarg(1,parm); read(parm,*) Tzero
    call getarg(2,parm); read(parm,*) Vzero
    call getarg(3,filenameIn)
    call getarg(4,filenameOut)
  elseif(iargc().eq.2) then
    Tzero=-1
    Vzero=-1
    call getarg(1,filenameIn)
    call getarg(2,filenameOut)
  else
    write(*,'(A)') "Usage: ./ConvertVegetYo (Start_Time) (Start_Value) [input.nc] [output.nc]"
    stop
  endif



          !!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! OPEN INPUT FILE !!!!    --> OUVRE LE NETCDF
          !!!!!!!!!!!!!!!!!!!!!!!!!

  write(*,*) "Open ", trim(filenameIn)
  call check(nf90_open(filenameIn, nf90_nowrite, intputID))
  call check(nf90_inquire(intputID, unlimitedDimId = unlimDimID))

  call check(nf90_inq_varid(intputID, "longitude", ID))
  allocate(lon(720))
  call check(nf90_get_var(intputID, ID, lon, (/ 1 /), (/ 720 /)))

  call check(nf90_inq_varid(intputID, "latitude", ID))
  allocate(lat(360))
  call check(nf90_get_var(intputID, ID, lat, (/ 1 /), (/ 360 /)))

  call check(nf90_inq_varid(intputID, "time", ID))
  call check(nf90_inquire_dimension(intputID, unlimDimID, len = nbTime))
  allocate(time(nbTime))
  call check(nf90_get_var(intputID, ID, time, (/ 1 /), (/ nbTime /)))

  call check(nf90_inq_varid(intputID, "vegfract", varID))
 

        	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!     CREE NETCDF POUR STOCKER LES RESULTATS      !!!!
					!!!!     CA SERT A POUVOIR VERIFIER SI CE QUI EST    !!!!
					!!!!     INSCRIT DANS LE BINAIRE EST CORRECT         !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !write target file
  write(*,*) "Create ", trim(filenameOut)
  call check(nf90_create(filenameOut, nf90_clobber, outputID))
  

  !define dimension
  call check(nf90_def_dim(outputID, "lon", 64, outdimid))
  call check(nf90_def_var(outputID, "lon", NF90_FLOAT, (/ 1 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "longitude coordinate"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "longitude"))
  call check(nf90_put_att(outputID, outvarid, "units", "degrees_east"))
  call check(nf90_put_att(outputID, outvarid, "axis", "X"))

  call check(nf90_def_dim(outputID, "lat", 32, outdimid))
  call check(nf90_def_var(outputID, "lat", NF90_FLOAT, (/ 2 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "latitude coordinate"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "latitude"))
  call check(nf90_put_att(outputID, outvarid, "units", "degrees_north"))
  call check(nf90_put_att(outputID, outvarid, "axis", "Y"))
  !NF90_UNLIMITED
  call check(nf90_def_dim(outputID, "time", NF90_UNLIMITED, outdimid))
  call check(nf90_def_var(outputID, "time", NF90_FLOAT, (/ 3 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "time"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "time"))
  call check(nf90_put_att(outputID, outvarid, "units", "years since 0001-01-01 00:00:00"))
  call check(nf90_put_att(outputID, outvarid, "time_origin", "01-JAN-0001 00:00:00"))

  !define variable
  call check(nf90_def_var(outputID, "vegfrac", NF90_FLOAT, (/ 1, 2, 3 /), outvarid))
  call check(nf90_put_att(outputID, outvarid, "long_name", "fraction de culture par maille"))
  call check(nf90_put_att(outputID, outvarid, "standard_name", "fraction_culture"))
  call check(nf90_put_att(outputID, outvarid, "units", "%"))
  call check(nf90_put_att(outputID, outvarid, "missing_value", real(-99.99)))

  !finish the configuration of the output file
  call check(nf90_enddef(outputID))



          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! LECTURE DU NETCDF ET MISE DANS LA BONNE GRILLE !!!!  
          !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  ! --> On passe d'une grille de "360 x 720" à une grille de "32 x 64"

  nlat=32
  nlon=64

  allocate(lat_ecbilt(nlat))
  allocate(lon_ecbilt(nlon))
  allocate(iyr_tab(1))
  allocate(iyr_tab2(1))
  allocate(ValueVar(size(lon)*size(lat)))
  allocate(ValueOneYear(size(lon),size(lat),1,1))
       
       
  do iyr=1,size(time)!
    write(*,*) "Interpo : ", int(time(iyr))

    !call check(nf90_get_var(intputID, varID, ValueOneYear, (/ 1, 1, 1, iyr /), (/ size(lon),size(lat),12,1 /)))
    call check(nf90_get_var(intputID, varID, ValueOneYear, (/ 1, 1, 1, iyr /), (/ size(lon),size(lat),1,1 /)))
    !data_crop(:,:)=ValueOneYear(:,:,12,1)+ValueOneYear(:,:,13,1)+ValueOneYear(:,:,14,1)
    data_crop(:,:)=ValueOneYear(:,:,1,1)

    farea(:,:,1)=0.!											REMPLIR LA MATRICE farea DE 0


					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE LES BORNES DE CHACUNE DES     !!!!
					!!!!         CELLULES DE LA GRILLE D'ECBILT          !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        
    do clat=1,nlat!											POUR LES LATITUDES ALLANT DE 1 à 32
      y1=-90+((clat-1)*5.625)!						(x1,x2,y1,y2)
      y2=y1+5.625
      lat_ecbilt(clat)=y1+5.625/2.
      
      do clon=1,nlon!										POUR LES LONGITUDES ALLANT DE 1 à 64
        compt=0.!											ON INITIALISE LE COMPTEUR à 0
        x1=-2.81+((clon-1)*5.625)!						ON CALCULE LES BORNES DE LA CELLULES DE LA MAILLE
        x2=x1+5.625!									DE LA GRILLE D'ECBILT QU'ON TRAITE
        lon_ecbilt(clon)=x1+5.625/2.
        iLatMin=(clat-1)*11.25-1
        iLatMax=(clat)*11.25+1
		    if(iLatMax>360) iLatMax=360
		    if(iLatMin<1) iLatMin=1

					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE LES VALEURS QUI DOIVENT       !!!!
					!!!!    REMPLIR LES CELLULES DE LA GRILLE D'ECBILT   !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       		
        do ilat=iLatMin,iLatMax
          do jlong=1,720

            if (data_crop(jlong,ilat).gt.0.) then!   >0 pour ne pas prendre missing values
              xi=-179.25+((jlong-1)*0.5)

              if (xi.lt.-2.75) xi=xi+360
              ! yi=89.75-((ilat-1)*0.5)
              yi=lat(ilat)

              if(((xi.lt.x2).and.(xi.gt.x1)).and.((yi.lt.y2).and.(yi.gt.y1))) then
                farea(clon,clat,1)=farea(clon,clat,1)+data_crop(jlong,ilat)
                compt=compt+1
              endif

            endif
          enddo
        enddo

        if (compt.ne.0) farea(clon,clat,1)=farea(clon,clat,1)/compt
        if (compt.eq.0) farea(clon,clat,1)=-99.99
      enddo
    enddo

					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!    ICI ON CALCULE L'INTERPOLATION ENTRE LA      !!!!
					!!!!            PREMIERE ANNEE ET L'AN 1             !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     write(*,*) iyr
     if((iyr.eq.1).and.(Tzero.lt.time(1)).and.(Tzero.ne.-1)) then!		je fait l'interpos entre 0 et farea(clat,clon) -> 0 et 800 ans
        write(*,*) "Generate slope from", Tzero," to",int(time(1)-1)
        do tps=1, time(1)-Tzero-1
          do clat=1,nlat!			POUR LES LATITUDES ALLANT DE 1 à 32
            do clon=1,nlon! 		POUR LES LONGITUDES ALLANT DE 1 à 64
               if(farea(clon,clat,iyr).lt.9E36) then
                 if(farea(clon,clat,iyr).gt.Vzero) then
                  fareaInt(clon,clat,1)=((farea(clon,clat,iyr)-Vzero)/(time(1)-Tzero))*tps+Vzero
                 else
                  fareaInt(clon,clat,1)=farea(clon,clat,iyr)
                 endif
               else
                 fareaInt(clon,clat,1)=-99.99    
               endif
            enddo
          enddo
            
          iyr_tab(1)=tps  
          call check(nf90_put_var(outputID, 3, iyr_tab, (/tps/), (/ 1 /))) 
          call check(nf90_put_var(outputID, outvarid, fareaInt, (/1, 1, tps/), (/64, 32, 1/)))
         enddo
     endif 
        
      
        	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					!!!!         FIN DE L'INTERPOLATION ENTRE LA         !!!!
					!!!!            PREMIERE ANNEE ET L'AN 0             !!!!
					!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  

   
    iyr_tab2(1)=iyr+time(1)-Tzero-1
    call check(nf90_put_var(outputID, 3, iyr_tab2, (/iyr_tab2/), (/ 1 /)))    


    Nty=iyr+time(1)-Tzero-1
    call check(nf90_put_var(outputID, outvarid, farea, (/1, 1, Nty/), (/64, 32, 1/)))
             
    !put data in lon variable
    call check(nf90_put_var(outputID, 1, lon_ecbilt, (/1/), (/64/)))
    !put data in lat variable
    call check(nf90_put_var(outputID, 2, lat_ecbilt, (/1/), (/32/)))



  enddo
  deallocate(ValueVar); deallocate(ValueOneYear);
 
 
 
 
          !!!!!!!!!!!!!!!!!!!!!!!!!!!
          !!!! CLOSE INPUT FILE  !!!!
          !!!!!!!!!!!!!!!!!!!!!!!!!!!

  call check(nf90_close(intputID))
  close(1)
  call check(nf90_close(outputID))

END PROGRAM crop_grille_ecbilt





SUBROUTINE check(status)
    USE NETCDF
    IMPLICIT NONE
    
    INTEGER, INTENT (IN) :: status
    if(status /= nf90_noerr) then 
      write(*,*)"Error  : ", trim(nf90_strerror(status))
      stop 
    end if
END SUBROUTINE check  



