subroutine usage()
  write(6,'(A)') "Usage:"
  write(6,'(A)') "  ./Gradsifaire [file.nc]"
  write(6,'(A)') "  Becarefull file is overwrited"
  stop
end subroutine usage

include "NetcdfFonction.f90"

PROGRAM Gradsifaire
  USE NETCDF
  IMPLICIT NONE
  
  
  
  CHARACTER(nf90_max_name) :: filename, dimName
  INTEGER :: fileID, RecordDimID, VarID, LonDimID, LatDimID
  INTEGER :: totaltime, getTime, getLonOrLatID, nlat, nlon, iargc, i
  double precision, dimension(:), allocatable :: value

  !GET ARGUMENT FOR SELECT METHODE
  if(iargc().ne.1) then
    call usage()
  else
    call getarg(1,filename)
  endif

  call check(nf90_open(filename, nf90_write, fileID))


  totaltime=getTime(fileID, RecordDimID)
  call check(nf90_inq_varid(fileID, "time", VarID))
  allocate(value(totaltime))

  do i=1, totaltime
    value(i)=i
  enddo
  call check(nf90_put_var(fileID, VarID, value, (/ 1 /), (/ totaltime /)))
  deallocate(value)


  LonDimID=getLonOrLatID(fileID,1)
  if(LonDimID.eq.-1) then
    call check(nf90_def_dim(fileID, "Lon", 1, LonDimID))
    call check(nf90_def_var(fileID, "Lon", NF90_DOUBLE, (/LonDimID/), VarID))
    allocate(value(1)); value=1
    call check(nf90_put_var(fileID, VarID, value, (/1/), (/1/)))
    deallocate(value)
  else
    call check(nf90_inquire_dimension(fileID, LonDimID, name=dimName, len=nlon))
    call check(nf90_inq_varid(fileID, dimName, VarID))
    if(nlon.eq.1) then
      allocate(value(1)); value=1
      call check(nf90_put_var(fileID, VarID, value))
      deallocate(value)
    endif
  endif
  call check(nf90_put_att(fileID, VarID, "axis", "X"))

  

  LatDimID=getLonOrLatID(fileID,0)
  if(LatDimID.eq.-1) then
    call check(nf90_def_dim(fileID, "Lat", 1, LatDimID))
    call check(nf90_def_var(fileID, "Lat", NF90_DOUBLE, (/LatDimID/), VarID))
    allocate(value(1)); value=1
    call check(nf90_put_var(fileID, VarID, value, (/1/), (/1/)))
    deallocate(value)
  else
    call check(nf90_inquire_dimension(fileID, LatDimID, name=dimName, len=nlat))
    call check(nf90_inq_varid(fileID, dimName, VarID))
    if(nlat.eq.1) then
      allocate(value(1)); value=1
      call check(nf90_put_var(fileID, VarID, value))
      deallocate(value)
    endif
  endif
  call check(nf90_put_att(fileID, VarID, "axis", "Y"))

  call check(nf90_close(fileID));
END PROGRAM Gradsifaire



