#!/bin/bash

if [ $# == 1 ]; then cd $1; fi

while [ 1 ]
do
  i=0
  string=""
  while [ -f log/sub$(( 1000+$i ))P.log ]
  do
    particleName="$(( 1000+$i ))P"
    var[$i]=`tail -n 1 log/sub${particleName}.log`

    testname1=${var[$i]} #${var[$i]:0:5}
    testname2=${var[$i]:0:6}
    if let ${testname2} 2>/dev/null; then
      run=1
      testname2=`printf "%06d" ${var[$i]:0:6}` 
    else
      run=0
    fi

    if [ "${testname1}" == " ###############################" ]; then
      #echo ${testname1}"-->OK"
      string="${string}\033[7;33m\t$particleName(WAIT)\033[0;30m"
      stat[$i]=0
    elif [ ${run} == "1" ]; then
      #echo ${testname2}"-->RUN"   
      string="${string}\033[7;32m\t$particleName(${testname2})\033[0;30m"
      stat[$i]=0
    else
      #echo ${testname2}"-->OTHER"
      stat[$i]=$(( stat[$i]+1 ))
      if [ ${stat[$i]} -gt 3 ]; then
        string="${string}\033[7;31m\t$particleName(/!\\)\033[0;30m" 
      else
        string="${string}\033[7;30m\t$particleName(?)\033[0;30m"
      fi
    fi

    i=$(( $i+1 ))
    if [ $(( ${i}%10 )) -eq 0 ] ; then
      string="${string}\n"
    fi
  done
  output=`tail -n 1 log/outputs.log`
  outputdate=`grep ".dat #########" log/outputs.log | tail -n 1`
  outputdate=${outputdate:$(( ${#outputdate}-24 )):10}

  moyratio=0
  nfile=0
  fcoststring=""
  for file in `ls -tr fcosts/*.dat | tail -n 5`
  do 
    # particule kept
    npartdelete=`cat ${file} | grep " 0 " | wc -l` ; 
    nparttotale=`cat ${file} | grep " 1 " | wc -l`
    ratio=`echo "scale=0 ; 100*($nparttotale-$npartdelete)/$nparttotale" | bc -l`
    zfile=`basename ${file}`

    if [ ${ratio} -lt 10 ]; then
      fcoststring="${fcoststring}\t${zfile} -> \033[7;31m${ratio}% particules kept\033[0;30m"
    elif [ ${ratio} -lt 20 ]; then
      fcoststring="${fcoststring}\t${zfile} -> \033[7;33m${ratio}% particules kept\033[0;30m"
    elif [ ${ratio} -lt 40 ]; then
      fcoststring="${fcoststring}\t${zfile} -> \033[7;32m${ratio}% particules kept\033[0;30m"
    elif [ ${ratio} -lt 70 ]; then
      fcoststring="${fcoststring}\t${zfile} -> \033[7;33m${ratio}% particules kept\033[0;30m"
    else
      fcoststring="${fcoststring}\t${zfile} -> \033[7;31m${ratio}% particules kept\033[0;30m"
    fi

    minmax=`tail -n ${i} ${file} | awk 'BEGIN {}; min=="" {min=max=$2}; { if ($2 > max) {max = $2}; if ($2 < min) {min = $2}; }END {print " min "min" max "max;}'`
    fcoststring="${fcoststring}${minmax}\n"
  done

  clear
  date
  echo -e "_________________________"
  echo ""
  echo "Particles :"
  echo -e ${string}
  echo -e "_________________________"
  echo ""
  echo -e "Output :"
  echo -e "\t${outputdate} -> ${output}"
  echo -e "_________________________"
  echo ""
  echo -e "Fcost (5 last) :"
  echo -e "${fcoststring}"
  sleep 10
done

