#!/bin/bash

if [ $# -ne 3 ]; then
  echo "Usage:"
  echo "   ./MontlyMean [input.nc] [length] [output.nc]"
  exit
fi

input=$1
length=$2
output=$3


path=`dirname ${output}`
filename=`basename ${output}`
tempdir=${path}/${filename}MoyenneYoTEMP
mkdir -p ${tempdir}

for t in `seq 1 12 ${length}`
do
  echo ${t} $(( ${t}+11 ))
  ncks -O -F -d time,${t},$(( ${t}+11 )) ${input} ${tempdir}/${t}.nc
done
ncea -O ${tempdir}/* ${output}
rm -rf ${tempdir}
