	PROGRAM TEST
	REAL e,eps,w,timey
	common/epsil/as(47),f1(47),delt1(47)
	common/rest1/rm(19),gg(19),beta(19),f2(10),f3(10),delt2(10)

	open(unit=17,file='astro.cray.dat',status='old')

c       
c       read data from file astro.dat
c       
c       read table 1
c       
	do 201 i=1,47
 201	   read(17,301) as(i),f1(i),delt1(i)
 301	   format(9x,f8.2,6x,f9.6,2x,f6.2)
c       
c       read table 4
c       
	   do 401 i=1,19
 401	      read(17,302) rm(i),gg(i),beta(i)
 302	      format(11x,f11.8,2x,f10.7,3x,f6.2)
c       
c       read table 5
c       
	      do 601 i=1,10
 601		 read(17,303) f2(i),f3(i),delt2(i)
 303		 format(9x,f8.2,8x,f9.6,5x,f6.2)
c       
c       end reading   astro.dat
c       

	read(*,*) timey
	CALL astro(e,eps,w,timey)
	write(6,11) e
	write(6,12) eps
	write(6,13) w
 11	FORMAT(F9.6)
 12	FORMAT(F6.2)
 13	FORMAT(F6.2)
	END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine astro(e,eps,w,timey)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     computes the eccentricity,the obliquity and
c     the precession   (berger 1978)
c
c     e=eccentricty  ( no units)
c     eps= obliquity ( degrees)
c     w= measured from ve to perihelion in c.c direction and
c        substract 180 degrees
c     timey= time in  years, negative for before present
c
      implicit real (a-h,o-z)
      common/epsil/as(47),f1(47),delt1(47)
      common/rest1/rm(19),gg(19),beta(19),f2(10),f3(10),delt2(10)
c
      call orbit1(eps,timey)
      call orbit2(w,e,timey)
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine orbit1(eps,timey)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  this subroutine computes the obliquity parameter
c
      implicit real (a-h,o-z)
      common/epsil/as(47),f1(47),delt1(47)
      eps=0.0e0
      epstar=23.320556e0 ! degrees
      pic=acos(-1.0e0)/180.0e0
      do 10 i=1,47
         eps=eps+(as(i)/3600.e0)*cos(((f1(i)*timey)/3600.e0+delt1(i))
     +    *pic)
10    continue
      eps=epstar+eps
c     eps is in degrees
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine orbit2(w,e,timey)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  this subroutine computes w and e (for subroutine astro)
c
      implicit real (a-h,o-z)
      common/rest1/rm(19),gg(19),beta(19),f2(10),f3(10),delt2(10)
      psitwi=50.439273e0  !seconds
      zeta= 3.392506 ! degrees
      pic=acos(-1.0e0)/180.0e0
      pi=acos(-1.0e0)
c
c  compute psi
c
      psi=0.0e0
      do 10 i=1,10
         psi=psi+(f2(i)/3600.e0)*sin(((f3(i)/3600.e0)*timey+delt2(i))
     +   *pic)
10    continue
c  psi is in degrees
      psi=(psitwi/3600.0e0)*timey+ zeta + psi
      psi=psi*pic
c  psi is in radians
      cospsi=cos(psi)
      sinpsi=sin(psi)
c  compute esinpi and ecospi
      sum1=0.0e0
      sum2=0.0e0
      do 20 i=1,19
         sum1=sum1+rm(i)*sin(((gg(i)/3600.e0)*timey+beta(i))*pic)
         sum2=sum2+rm(i)*cos(((gg(i)/3600.e0)*timey+beta(i))*pic)
20    continue
      esinpi=sum1
      ecospi=sum2
      esinw=esinpi*cospsi+ecospi*sinpsi
      ecosw=ecospi*cospsi-esinpi*sinpsi
c     check in what quadrants cosw and sinw are, and assign proper sign:
c   1. do cases that are on x or y axes:
      if(ecosw>0.0e0.and.esinw.eq.0.0e0) w=0.0e0
      if(ecosw<0.0e0.and.esinw.eq.0.0e0) w=pi
      if(ecosw.eq.0.0e0.and.esinw>0.0e0) w=pi/2.0e0
      if(ecosw.eq.0.0e0.and.esinw<0.0e0) w=1.5e0*pi
      if(esinw.eq.0.0e0.or.ecosw.eq.0.0e0) go to 21
      w=atan(esinw/ecosw)
c   2. do cases that are not on the x or y axes:
c     quadrant i:
      if(ecosw>0.0e0.and.esinw>0.0e0) w=abs(w)
c     quadrant ii:
      if(ecosw<0.0e0.and.esinw>0.0e0) w=pi-abs(w)
c     quadrant iii:
      if(ecosw<0.0e0.and.esinw<0.0e0) w=pi+abs(w)
c     quadrant iv:
      if(ecosw>0.0e0.and.esinw<0.0e0) w=2*pi-abs(w)
c     compute e:
21    continue
      w1test=abs(sin(w))
      if(w1test>0.1e0) then
         e= abs(esinw/sin(w))
      else
         e= abs(ecosw/cos(w))
      endif
c     convert w from radians to degrees
      w=w/pic
      return
      end

